//NewProjectDlg.cpp
#include "TextControl.h"

#include "NewProjectDlg.h"
#include "TextModel.h"
#include "Application.h"
#include "Frame.h"
#include "CommonFileBrowse.h"

using namespace VCF;

NewProjectDlg::NewProjectDlg()
{
	Application* app = Application::getRunningInstance();
	if ( NULL != app ){
		Frame* frame = this;
		app->loadFrame( &frame );		
	}
	vcfInit();
}

NewProjectDlg::~NewProjectDlg()
{

}

void NewProjectDlg::vcfInit()
{
	
	this->bindVariable( (VCF::Component**)&Label1, "Label1" );
	this->bindVariable( (VCF::Component**)&projectName, "projectName" );
	this->bindVariable( (VCF::Component**)&Label2, "Label2" );
	this->bindVariable( (VCF::Component**)&TextControl1, "TextControl1" );
	this->bindVariable( (VCF::Component**)&browseForProjDir, "browseForProjDir" );
	this->bindVariable( (VCF::Component**)&CommandButton1, "CommandButton1" );
	this->bindVariable( (VCF::Component**)&CommandButton2, "CommandButton2" );

	ButtonHandler* bh = new ButtonHandler( this );
	bh->m_buttonClicked = (OnButtonEvent)onBrowseForDirClicked;
	
	this->addEventHandler( "onBrowseForDirClicked", bh );
	browseForProjDir->addButtonListener( bh );
}//vcfInit finished

VCF::String NewProjectDlg::getProjDir()
{
	return this->TextControl1->getTextModel()->getText();
}

VCF::String NewProjectDlg::getProjName()
{
	return this->projectName->getTextModel()->getText();
}

void NewProjectDlg::onBrowseForDirClicked( ButtonEvent* event )
{
	CommonFileBrowse dlg;
	dlg.setTitle( "Browse For Project" );
	if ( true == dlg.execute() ){
		TextControl1->getTextModel()->setText( dlg.getDirectory() );
	}
}