/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

#ifndef _VCFABOUT_H__
#define _VCFABOUT_H__


#include "Dialog.h"
#include "Image.h"
#include "Application.h"

namespace VCF {

class VCFAbout : public Dialog{

public:
	VCFAbout(){
		m_img = NULL;
		Application* app = Application::getRunningInstance();
		m_img = app->getResourceBundle()->getImage( "VCFLOGO" );
		setFrameStyle( FST_NOBORDER_FIXED );
		setTop( 400 );
		setLeft( 400 );
		setWidth( m_img->getWidth() );	
		setHeight( m_img->getHeight() );
	};	

	virtual ~VCFAbout(){
		if ( NULL != m_img ){
			delete m_img;			
		}
		m_img = NULL;
	};


	virtual void paint( GraphicsContext* ctx ){
		Dialog::paint( ctx );
		ctx->drawImage( 0, 0, m_img );
	}
	
	virtual void mouseUp(  MouseEvent* event ){
		this->close();
	}

private:
	Image* m_img;
};

}; //end of namespace VCF

#endif //_VCFABOUT_H__