/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

#ifndef _VCFFILE_H__
#define _VCFFILE_H__


#include "Object.h"

namespace VCF {

class Frame;

class VCFProject;

class VCFFile : public Object{

public:
	VCFFile( VCFProject* project, Frame* frame );

	virtual ~VCFFile();

	VCFProject* getProject(){
		return m_project;
	}

	String getCppFileName(){
		return m_cppFileName;
	}

	String getHFileName(){
		return m_hFileName;
	}

	String getVFFFileName(){
		return m_VFFFileName;
	}

	Frame* getFrame() {
		return m_frame;
	}
		
	void setVFFFileName( const String& val ){
		m_VFFFileName = val;
	}

	void setCppFileName( const String& val ){
		m_cppFileName = val;
	}

	void setHFileName( const String& val ){
		m_hFileName = val;
	}
	void updateFileNames();
private:
	String m_cppFileName;
	String m_hFileName;
	Frame* m_frame;
	VCFProject* m_project;
	String m_VFFFileName;

};

}; //end of namespace VCF

#endif //_VCFFILE_H__