/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

#ifndef _VCFPROJECT_H__
#define _VCFPROJECT_H__

#include "Object.h"
#include "Persistable.h"
#include "Stream.h"
#include "Enumerator.h"
#include <map>

namespace VCF {

class Frame;

class VCFFile;

class VCFProject :public Object, public Persistable{
public:
	VCFProject();

	virtual ~VCFProject();

	String getName(){
		return m_name;
	}

	void setName( const String& name ){
		m_name = name;
	}

	void addToProject( Frame* frameWindow );

	String getProjectDir(){
		return m_projDir;
	}

	void setProjectDir( const String& projDir ){
		m_projDir = projDir;
	}

	virtual void saveToStream( OutputStream * stream );
	
    virtual void loadFromStream( InputStream * stream );

	Enumerator<VCFFile*>* getFiles();
private:
	String m_name;
	std::map<String,VCFFile*> m_fileListingMap;
	EnumeratorMapContainer<std::map<String,VCFFile*>,VCFFile*> m_fileContainer;
	String m_projDir;
};

}; //end of namespace VCF

#endif //_VCFPROJECT_H__