/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

#include "VCFBuilderDialog.h"
#include "CommandButton.h"
#include "Panel.h"
#include "Rect.h"
using namespace VCF;


VCFBuilderDialog::VCFBuilderDialog( Frame* owner ):
	Dialog( owner )
{
	this->init();
}

VCFBuilderDialog::~VCFBuilderDialog()
{

}

void VCFBuilderDialog::init()
{
	m_btnPanel = new Panel();
	Rect bounds(0,0,100,10);
	m_btnPanel->setBounds( &bounds );
	this->add( m_btnPanel, ALIGN_RIGHT );

	m_OKBtn = new CommandButton();
	m_OKBtn->setCaption( "OK" );
	bounds.setRect( 10, 10, 80, 35 );
	m_OKBtn->setBounds( &bounds );
	m_btnPanel->add( m_OKBtn );

	m_cancelBtn = new CommandButton();
	m_cancelBtn->setCaption( "Cancel" );
	bounds.setRect( 10, 45, 80, 70 );
	m_cancelBtn->setBounds( &bounds );
	m_btnPanel->add( m_cancelBtn );

	m_contents = new Panel();
	this->add( m_contents, ALIGN_CLIENT );	
}
