/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

#ifndef _ABSTRACTTABLEMODEL_H__
#define _ABSTRACTTABLEMODEL_H__

#include "TableModel.h"

namespace VCF {

#define ABSTRACTTABLEMODEL_CLASSID		"BCA97CD4-6567-11d4-8EFF-00207811CFAB"

class APPKIT_API AbstractTableModel : public TableModel{
public:
	BEGIN_ABSTRACT_CLASSINFO(AbstractTableModel, "VCF::AbstractTableModel", "VCF::TableModel", ABSTRACTTABLEMODEL_CLASSID );
	END_CLASSINFO(AbstractTableModel);

	AbstractTableModel();

	virtual ~AbstractTableModel();

	virtual void removeTableModelListener(TableModelListener * listener);

    virtual void addTableModelListener(TableModelListener * listener);

    virtual void addRow();

	virtual void insertRow( const uint32& afterRow );

	virtual void deleteRow( const uint32& row );

    virtual void addColumn();

	virtual void insertColumn( const uint32& afterColumn );

	virtual void deleteColumn( const uint32& column );

	virtual bool isCellEditable( const uint32& row, const uint32& column );

	virtual TableCellItem* getItem( const uint32& row, const uint32& column );
	
	virtual uint32 getRowCount();

	virtual uint32 getColumnCount();
};

}; //end of namespace VCF

#endif //_ABSTRACTTABLEMODEL_H__