/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef COMBOBOXCONTROL_H
#define COMBOBOXCONTROL_H
#include "VCF.h"
#include "CustomControl.h"
#include "Rect.h"
#include "ComboBoxListener.h"
#include "ItemEvent.h"


namespace VCF{

class ListModel;

class ComboBoxPeer;

class ListModelEvent;

class ListModelHandler;

class ListItem;

#define COMBOBOXCONTROL_CLASSID		"4A9D66D5-3B26-11d4-B54C-00C04F0196DA"

class APPKIT_API ComboBoxControl : public VCF::CustomControl {
public:

	BEGIN_CLASSINFO(ComboBoxControl, "VCF::ComboBoxControl", "VCF::CustomControl", COMBOBOXCONTROL_CLASSID )
	END_CLASSINFO(ComboBoxControl)

	ComboBoxControl();

	virtual ~ComboBoxControl();

	void init();

	/**
	*This macro declares a std::vector<> of ComboBoxListener listeners
	*/
	LISTENER_LIST(ComboBoxListener);

	/**
	*This macro creates a method for adding a listener to the ComboBoxControl's events
	*/
	ADD_LISTENER(ComboBoxListener);

	/**
	*This macro creates a method for removing a listener to the ComboBoxControl's events
	*/
	REMOVE_LISTENER(ComboBoxListener);

	/**
	*ComboBoxControl events
	*/
	NOTIFIER(ComboBoxListener, onSelectionChange, ItemEvent);

    ListModel* getListModel();

    void setListModel(ListModel * model); 

	virtual void paint( GraphicsContext* context );

	void onListModelContentsChanged( ListModelEvent* event );

    void onItemAdded( ListModelEvent* event );

    void onItemDeleted( ListModelEvent* event );

	virtual void mouseDown( MouseEvent* event );

	virtual void mouseMove( MouseEvent* event );

	virtual void mouseUp( MouseEvent* event );

	virtual void keyPressed( KeyboardEvent* event );

	ListItem* getSelectedItem();

	void setSelectedItem( ListItem* selectedItem );

	void setSelectedItemIndex( const ulong32& selectedIndex );

private:    
    //ComboBoxPeer * m_comboBoxPeer;
	ListModel* m_listModel;
	ListModelHandler* m_modelHandler;
	ulong32 m_selectedIndex;
	bool m_arrowPressed;
	Rect m_arrowRect;
};

};

#endif //COMBOBOXCONTROL_H