/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */


#ifndef COMMANDBUTTON_H
#define COMMANDBUTTON_H

#include "VCF.h"
#include "Button.h"
#include "Control.h"
#include "ButtonListener.h"
#include "ButtonEvent.h"

namespace VCF{


class ButtonPeer;

enum ButtonCommandType{
	BC_NONE=0,
	BC_OK,
	BC_CANCEL,
	BC_YES,
	BC_NO,
	BC_MAYBE
};

static String ButtonCommandTypeNames[] = { "BC_NONE", 
                                         "BC_OK", 
										 "BC_CANCEL", 
										 "BC_YES", 
										 "BC_NO", 
										 "BC_MAYBE" };

#define COMMANDBUTTON_CLASSID		"8B2CDC30-3CAD-11d4-B553-00C04F0196DA"

/**
 * Command button is a representation of a Win32 BUTTON class. 
 */
class APPKIT_API CommandButton :  public VCF::Control, public VCF::Button {
public:
	BEGIN_CLASSINFO(CommandButton, "VCF::CommandButton", "VCF::Control", COMMANDBUTTON_CLASSID)
	PROPERTY( String, "caption", CommandButton::getCaption, CommandButton::setCaption, PROP_STRING );		
	LABELED_ENUM_PROPERTY( ButtonCommandType, "commandType", CommandButton::getCommandType, CommandButton::setCommandType, 
						   BC_NONE, BC_MAYBE, 6, ButtonCommandTypeNames);	
	END_CLASSINFO(CommandButton)

	CommandButton();

	virtual ~CommandButton();

	LISTENER_LIST(ButtonListener);

	/**
	*This macro creates a method for adding a listener to the CommandButton's events
	*/
	ADD_LISTENER(ButtonListener);

	/**
	*This macro creates a method for removing a listener to the CommandButton's events
	*/
	REMOVE_LISTENER(ButtonListener);

	NOTIFIER(ButtonListener, onButtonClicked, ButtonEvent);

    virtual void click();

    void setCaption( const String& caption );

    String getCaption();

	ButtonCommandType getCommandType();

	void setCommandType( const ButtonCommandType& commandType );

	virtual void paint(GraphicsContext * context);
private:    
    ButtonPeer * m_buttonPeer;
    String m_caption;
	ButtonCommandType m_commandType;
};

}
#endif //COMMANDBUTTON_H