/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

//CommonDefines.h

#ifndef _COMMON_DEFINES_H__
#define _COMMON_DEFINES_H__

#include "VCFString.h"

namespace VCF
{

enum PropertyDescriptorType{
	PROP_UNDEFINED = 0,
	PROP_INT,
	PROP_LONG,
	PROP_SHORT,
	PROP_ULONG,
	PROP_FLOAT,
	PROP_CHAR,
	PROP_DOUBLE,
	PROP_OBJECT,
	PROP_BOOL,
	PROP_STRING,
	PROP_ENUM
};

enum AlignmentType{
    ALIGN_NONE=0,
    ALIGN_TOP,
    ALIGN_LEFT,
    ALIGN_RIGHT,
    ALIGN_BOTTOM,
    ALIGN_CLIENT
};

static String AlignmentTypeNames[] = { "ALIGN_NONE", 
                                         "ALIGN_TOP", 
										 "ALIGN_LEFT", 
										 "ALIGN_RIGHT", 
										 "ALIGN_BOTTOM", 
										 "ALIGN_CLIENT" };

enum IconStyleType {
	IS_LARGE_ICON=0,
	IS_SMALL_ICON,
	IS_LIST,
	IS_DETAILS
};

enum IconAlignType {
	IA_NONE=0,
	IA_TOP,
	IA_LEFT,
	IA_AUTO_ARRANGE
};

static String IconStyleTypeNames[] = { "IS_LARGE_ICON", 
                                         "IS_SMALL_ICON", 
										 "IS_LIST", 
										 "IS_DETAILS" };

static String IconAlignTypeNames[] = { "IA_NONE", 
                                         "IA_TOP", 
										 "IA_LEFT", 
										 "IA_AUTO_ARRANGE" };

/**
*Mouse button masks
*/
#define MOUSE_UNDEFINED					0
#define MOUSE_LEFT_BUTTON				1
#define MOUSE_MIDDLE_BUTTON				2
#define MOUSE_RIGHT_BUTTON				4

/**
*Keyboard masks
*/
#define KEY_UNDEFINED					0
#define KEY_ALT							1
#define KEY_SHIFT						2
#define KEY_CTRL						4


//conversion defines
#define INT_STR_CONVERSION			"%d "
#define LONG_STR_CONVERSION			"%d "
#define SHORT_STR_CONVERSION		"%d "
#define FLOAT_STR_CONVERSION		"%.5f "
#define DOUBLE_STR_CONVERSION		"%.5f "
#define BOOL_STR_CONVERSION_TRUE	"true "
#define BOOL_STR_CONVERSION_FALSE	"false "

#define STR_INT_CONVERSION			"%d"
#define STR_LONG_CONVERSION			"%d"
#define STR_ULONG_CONVERSION		"%d"
#define STR_CHAR_CONVERSION			"%c"
#define STR_SHORT_CONVERSION		"%d"
#define STR_FLOAT_CONVERSION		"%f"
#define STR_DOUBLE_CONVERSION		"%f"
#define STR_BOOL_CONVERSION_TRUE	"true"
#define STR_BOOL_CONVERSION_FALSE	"false"


#define VIRT_KEY_F1					200
#define VIRT_KEY_F2					201
#define VIRT_KEY_F3					202
#define VIRT_KEY_F4					203
#define VIRT_KEY_F5					204
#define VIRT_KEY_F6					205
#define VIRT_KEY_F7					206
#define VIRT_KEY_F8					207
#define VIRT_KEY_F9					208
#define VIRT_KEY_F10				209
#define VIRT_KEY_F11				210
#define VIRT_KEY_F12				211
#define VIRT_KEY_UP_ARROW			212
#define VIRT_KEY_LEFT_ARROW			213
#define VIRT_KEY_RIGHT_ARROW		214
#define VIRT_KEY_DOWN_ARROW			215
#define VIRT_KEY_PG_UP				216
#define VIRT_KEY_PG_DOWN			217

};
	

#endif