/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */


#ifndef CUSTOMCONTROL_H
#define CUSTOMCONTROL_H

#include "Control.h"


namespace VCF{

class CustomControlPeer;

#define CUSTOMCONTROL_CLASSID			"ED88C0A4-26AB-11d4-B539-00C04F0196DA"

class APPKIT_API CustomControl : public Control {
public:
	BEGIN_CLASSINFO(CustomControl, "VCF::CustomControl", "VCF::Control", CUSTOMCONTROL_CLASSID )
	END_CLASSINFO(CustomControl)

	CustomControl();
	
	CustomControl( const bool& useHeavyweightPeer );

	virtual ~CustomControl();

	virtual void paint(GraphicsContext * context);

	virtual void init();

	virtual bool isLighweight();

	/**
	*does this control allow the background of it's parent to show through ?
	*Currently only applicable to lightweight controls
	*/
	bool isTransparent();
	/**
	*sets whether or not the controls paints a background and covers it's parent
	*/
	void setTransparent( const bool& transparent );

private:
    CustomControlPeer * m_customControlPeer;     
	bool m_isLightweight;	
	bool m_isTransparent;
};

};

#endif //CUSTOMCONTROL_H