/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef DEFAULTLISTITEM_H
#define DEFAULTLISTITEM_H


#include "Object.h"
#include "ListItem.h"
#include "ItemListener.h"


namespace VCF{

#define DEFAULTLISTITEM_CLASSID		"ED88C0AC-26AB-11d4-B539-00C04F0196DA"

class APPKIT_API DefaultListItem : public ListItem {
public:

	BEGIN_CLASSINFO(DefaultListItem, "VCF::DefaultListItem", "VCF::ListItem", DEFAULTLISTITEM_CLASSID)
	END_CLASSINFO(DefaultListItem)

	DefaultListItem();

	DefaultListItem( Model* model );

	DefaultListItem( Model* model, const String& caption );

	virtual ~DefaultListItem();

	void init();

    virtual bool containsPoint( Point * pt );

	/**
	*This macro declares a std::vector<> of ItemListener listeners
	*/
	LISTENER_LIST(ItemListener);

	/**
	*This macro creates a method for adding a listener to the DefaultTreeItem's Item events
	*/
	ADD_LISTENER(ItemListener);

	/**
	*This macro creates a method for removing a listener to the DefaultTreeItem's Item events
	*/
	REMOVE_LISTENER(ItemListener);    
    
	NOTIFIER(ItemListener, onItemPaint, ItemEvent);

	NOTIFIER(ItemListener, onItemChanged, ItemEvent);

	NOTIFIER(ItemListener, onItemSelected, ItemEvent);

	NOTIFIER(ItemListener, onItemAdded, ItemEvent);

	NOTIFIER(ItemListener, onItemDeleted, ItemEvent);

	virtual Image* getImage();

    virtual unsigned long getIndex();

	virtual void setIndex( const unsigned long& index );

    virtual void* getData();

	virtual void setData( void* data );	

	virtual String getCaption();
	
	virtual void setCaption( const String& caption );

	virtual Model* getModel();

	virtual void setModel( Model* model );

	virtual void paint( GraphicsContext* context, Rect* paintRect );
	
	virtual bool isSelected();

	virtual void setSelected( const bool& selected );
private:
	Image* m_image;
	String m_caption;
	void* m_data;
	unsigned long m_index;
	Model* m_model;
	bool m_selected;
};

};

#endif //DEFAULTLISTITEM_H
