/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */


#ifndef DIALOG_H
#define DIALOG_H
#include "Frame.h"


namespace VCF{

class DialogPeer;

#define DIALOG_CLASSID		"ED88C09A-26AB-11d4-B539-00C04F0196DA"

enum MessageStyle {
	MS_DEFAULT = 0,
	MS_ERROR,
	MS_INFO,
	MS_WARNING
};

enum ModalReturnType {
	MRT_NONE = 0,
	MRT_OK,
	MRT_CANCEL,
	MRT_YES,
	MRT_NO
};

/**
 * A frame with a close button, and optionally a help and system button as well. The caption is the standard height. 
 */
class APPKIT_API Dialog : public Frame {
public:

	BEGIN_CLASSINFO(Dialog, "VCF::Dialog", "VCF::Frame", DIALOG_CLASSID )		
	END_CLASSINFO(Dialog)

	Dialog( Frame* owner=NULL );

	//Dialog( Frame* owner );

	virtual ~Dialog();

	virtual void setCaption( const String& caption );    

	virtual void paint(GraphicsContext * context);

	/**
	*overridden to take into account client bounds
	**/
	virtual void resizeChildren();

	virtual Rect* getClientBounds();

	virtual void setClientBounds( Rect* bounds );
	
	virtual ModalReturnType showModal();

	virtual void show();

	virtual void close();

	static void showMessage( const String& message, const String& caption="" );

	static ModalReturnType showMessage( const String& message, const MessageStyle& messageStyle, const String& caption="" ); 

	virtual void setFrameStyle( const FrameStyleType& frameStyle );
private:    
    DialogPeer * m_dialogPeer;
};

};

#endif //DIALOG_H