/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

//FrameworkConfig.h

/**
*Basic setup defines for Foundationkit Classes
*/

#ifndef _FRAMEWORK_CONFIG_H__
#define _FRAMEWORK_CONFIG_H__


#define KEEP_NAMESPACE_IN_CLASSNAME
//#define USE_GARBAGE_COLLECTION
#ifdef _WIN32
	#ifdef _DEBUG
	//	#define USE_VCF_NEW
	#endif
#endif


#ifdef _WIN32
/**
*The defines below come partly from the following article on STL exporting/importing
*from MS DLL's. 
*Remember Luke, Microsoft sucks, Microsoft is the Dark Side of the Force.
*HOWTO: Exporting STL Components Inside & Outside of a Class
*Last reviewed: January 19, 1998
*Article ID: Q168958 
*/
//disable warnings on 255 char debug symbols
	#pragma warning (disable : 4786)
//disable warnings on extern before template instantiation
	#pragma warning (disable : 4231)

	#pragma warning (disable : 4251)

	#pragma warning (disable : 4275)

	#ifdef FRAMEWORK_DLL

		#if defined(FRAMEWORK_EXPORTS) 
			#define FRAMEWORK_API __declspec(dllexport)
			#define FRAMEWORK_EXPIMP_TEMPLATE
		#else
			#define FRAMEWORK_API __declspec(dllimport)
			#define FRAMEWORK_EXPIMP_TEMPLATE extern
		#endif
	#else	
		#define FRAMEWORK_API
	#endif //FRAMEWORK_DLL

	#ifdef GRAPHICSKIT_DLL

		#if defined(GRAPHICSKIT_EXPORTS) 
			#define GRAPHICSKIT_API __declspec(dllexport)
			#define GRAPHICSKIT_EXPIMP_TEMPLATE
		#else
			#define GRAPHICSKIT_API __declspec(dllimport)
			#define GRAPHICSKIT_EXPIMP_TEMPLATE extern
		#endif
	#else	
		#define GRAPHICSKIT_API
	#endif //GRAPHICSKIT_DLL

	#ifdef APPKIT_DLL

		#if defined(APPKIT_EXPORTS) 
			#define APPKIT_API __declspec(dllexport)
			#define APPKIT_EXPIMP_TEMPLATE
		#else
			#define APPKIT_API __declspec(dllimport)
			#define APPKIT_EXPIMP_TEMPLATE extern
		#endif
	#else	
		#define APPKIT_API
	#endif //APPKIT_DLL

	#ifdef NETKIT_DLL

		#if defined(NETKIT_EXPORTS) 
			#define NETKIT_API __declspec(dllexport)
			#define NETKIT_EXPIMP_TEMPLATE
		#else
			#define NETKIT_API __declspec(dllimport)
			#define NETKIT_EXPIMP_TEMPLATE extern
		#endif
	#else	
		#define NETKIT_API
	#endif //APPKIT_DLL
#endif //_WIN32
#ifdef macintosh
	#define FRAMEWORK_API
#endif //macintosh

#endif

