/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef ITEM_H
#define ITEM_H

#include "Object.h"
#include "ClassInfo.h"

namespace VCF{



class ItemListener;

class Image;

class Model;

class ItemEvent;

class Rect;

class Point;

class GraphicsContext;

/** @interface */
	
#define ITEM_CLASSID		"ED88C0AA-26AB-11d4-B539-00C04F0196DA"
class APPKIT_API Item : public Object {
public:  
	BEGIN_ABSTRACT_CLASSINFO(Item, "VCF::Item", "VCF::Object", ITEM_CLASSID)
	END_CLASSINFO(Item)

	Item(){
		
	};

	virtual ~Item(){};

    virtual bool containsPoint( Point * pt ) = 0;

	virtual void addItemListener( ItemListener* listener ) = 0;
    
	virtual void removeItemListener( ItemListener* listener ) = 0;

	virtual Image* getImage() = 0;

    virtual unsigned long getIndex() = 0;

	virtual void setIndex( const unsigned long& index ) = 0;

    virtual void* getData() = 0;

	virtual void setData( void* data ) = 0;	

	virtual Model* getModel() = 0;

	virtual void setModel( Model* model ) = 0;

	virtual void paint( GraphicsContext* context, Rect* paintRect ) = 0;
	
	virtual bool isSelected() = 0;

	virtual void setSelected( const bool& selected ) = 0;

};

};
#endif //ITEM_H