/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */


#ifndef LISTBOXCONTROL_H
#define LISTBOXCONTROL_H

#include "Control.h"

namespace VCF{

class ListBoxPeer;

class ListModel;

class ListItem;

class ListModelEvent;

class ListModelHandler;

#define LISTBOXCONTROL_CLASSID		"ED88C0A5-26AB-11d4-B539-00C04F0196DA"

class APPKIT_API ListBoxControl : public Control {

public:
	BEGIN_CLASSINFO(ListBoxControl, "VCF::ListBoxControl", "VCF::Control", LISTBOXCONTROL_CLASSID )
	OBJECT_PROPERTY( ListModel, "listModel", ListBoxControl::getListModel, ListBoxControl::setListModel );
	END_CLASSINFO(ListBoxControl)

	ListBoxControl();

	virtual ~ListBoxControl();

    ListModel* getListModel();

    void setListModel(ListModel * model);

	virtual void paint( GraphicsContext * context ){};

	virtual void rangeSelect( const bool & isSelected, ListItem * first, ListItem * last );

	void onListModelContentsChanged( ListModelEvent* event );

    void onItemAdded( ListModelEvent* event );

    void onItemDeleted( ListModelEvent* event );

private:
    ListBoxPeer* m_listBoxPeer;
	ListModel* m_listModel;
	ListModelHandler* m_modelHandler;
};

};
#endif //LISTBOXCONTROL_H