/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together*/

#ifndef LISTMODEL_H
#define LISTMODEL_H

#include "Model.h"
#include "Enumerator.h"

namespace VCF{

class ListItem;

class ListModelListener;

/** @interface */

#define LISTMODEL_CLASSID		"ED88C0A8-26AB-11d4-B539-00C04F0196DA"

class APPKIT_API ListModel : public Model{
public:
	BEGIN_ABSTRACT_CLASSINFO(ListModel, "VCF::ListModel", "VCF::Model", LISTMODEL_CLASSID)
	OBJECT_COLLECTION_PROPERTY(ListItem*, "items", ListModel::getItems, ListModel::addItem, ListModel::insertItem, ListModel::deleteItem, ListModel::deleteItem )
	END_CLASSINFO(ListModel)

	ListModel(){

	};

	virtual ~ListModel(){};

    virtual void removeListModelListener(ListModelListener * listener) = 0;
    
	virtual void addListModelListener(ListModelListener * listener) = 0;  
    
	virtual void deleteItem(ListItem * item) = 0;
    
	virtual void deleteItem(const unsigned long & index) = 0;
    
	virtual void insertItem(const unsigned long & index, ListItem * item) = 0;

    virtual void addItem(ListItem * item) = 0;

	virtual ListItem* getItemFromIndex( const unsigned long& index ) = 0;

	virtual Enumerator<ListItem*>* getItems() = 0;

	/**
	*returns the number of the items in the model
	*/
	virtual unsigned long getCount() = 0;
};

}
#endif //LISTMODEL_H