/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef LISTVIEWCONTROL_H
#define LISTVIEWCONTROL_H

#include "Control.h"
#include "CommonDefines.h"

namespace VCF{

class ListModel;

class ListviewPeer;

class ListItem;

class ListModelHandler;

class ListModelEvent;

#define LISTVIEWCONTROL_CLASSID			"ED88C09D-26AB-11d4-B539-00C04F0196DA"

class APPKIT_API ListViewControl : public VCF::Control {

public:
	BEGIN_CLASSINFO(ListViewControl, "VCF::ListViewControl", "VCF::Control", LISTVIEWCONTROL_CLASSID )
	LABELED_ENUM_PROPERTY( IconStyleType, "iconStyle", ListViewControl::getIconStyle, ListViewControl::setIconStyle, 
						   IS_LARGE_ICON, IS_DETAILS, 4, IconStyleTypeNames);
	LABELED_ENUM_PROPERTY( IconAlignType, "iconAlignment", ListViewControl::getIconAlignment, ListViewControl::setIconAlignment, 
						   IA_NONE, IA_AUTO_ARRANGE, 4, IconAlignTypeNames);
	OBJECT_PROPERTY( ListModel, "listModel", ListViewControl::getListModel, ListViewControl::setListModel );
	
	END_CLASSINFO(ListViewControl)

	ListViewControl();

	virtual ~ListViewControl();

    ListModel* getListModel();

    void setListModel(ListModel * model);

	virtual void paint( GraphicsContext * context ){};

	void addHeaderColumn( const String& columnName );

	void insertHeaderColumn( const unsigned long& index, const String& columnName );

	void deleteHeaderColumn( const unsigned long& index );

	IconStyleType getIconStyle();

	void setIconStyle( const IconStyleType& iconStyle );

	bool getAllowsMultiSelect();

	void setAllowsMultiSelect( const bool& allowsMultiSelect );

	IconAlignType getIconAlignment();

	void setIconAlignment( const IconAlignType& iconAlignType );

	bool getAllowLabelEditing();

	void setAllowLabelEditing( const bool& allowLabelEditing );

	void setItemFocused( ListItem* item );

	//Events
	void onListModelContentsChanged( ListModelEvent* event );

    void onItemAdded( ListModelEvent* event );

    void onItemDeleted( ListModelEvent* event );
	
	virtual void init();

private:    
    ListviewPeer * m_listviewPeer;
	ListModel* m_listModel;
	ListModelHandler* m_modelHandler;
	IconStyleType m_iconStyle;
};



};
#endif //LISTVIEWCONTROL_H