/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef MENUITEM_H
#define MENUITEM_H

#include "Item.h"
#include "Enumerator.h"



namespace VCF 
{

class MenuItemPeer;

class MenuItemListener;

class Menu;

#define MENUITEM_CLASSID		"1E8CBE22-2915-11d4-8E88-00207811CFAB"

class APPKIT_API MenuItem : public Item {
public:

	BEGIN_ABSTRACT_CLASSINFO(MenuItem, "VCF::MenuItem", "VCF::Item", MENUITEM_CLASSID)
	END_CLASSINFO(MenuItem)

	MenuItem(){
		
	};

	virtual ~MenuItem(){};

	virtual void addMenuItemListener( MenuItemListener* listener ) = 0;

	virtual void removeMenuItemListener( MenuItemListener* listener ) = 0;

	virtual Enumerator<MenuItem*>* getChildren() = 0;	

	virtual void addChild( MenuItem* child ) = 0;

	virtual void insertChild( const unsigned long& index, MenuItem* child ) = 0;
	
	virtual void deleteChild( MenuItem* child ) = 0;

	virtual void deleteChild( const unsigned long& index ) = 0;

	virtual void clearChildren() = 0;

	virtual bool isChecked() = 0;

	virtual void setChecked( const bool& checked ) = 0;

	virtual bool hasParent() = 0;

	virtual bool hasChildren() = 0;

	/**
	*returns the owner of the menu item. This generally
	is either a MenuBar or a PopupMenu
	*/
	virtual Menu* getMenuOwner() = 0;

	/**
	*sets the Owner for the MenuItem and for all it's children as 
	*well
	*/
	virtual void setMenuOwner( Menu* menuOwner ) = 0;

	virtual MenuItem* getParent() = 0;

	virtual void setParent( MenuItem* parent ) = 0;

	virtual MenuItem* getChildAt( const unsigned long& index ) = 0;

	virtual bool isEnabled() = 0;

	virtual void setEnabled( const bool& enabled ) = 0;

	virtual bool isVisible() = 0;

	virtual void setVisible( const bool& visible ) = 0;

	virtual bool getRadioItem() = 0;

	virtual void setRadioItem( const bool& value ) = 0;

	virtual void setCaption( const String& caption ) = 0;
	
	virtual String getCaption() = 0;

	virtual MenuItemPeer* getPeer() = 0;

	virtual bool isSeparator() = 0;

	virtual void setSeparator( const bool& separator ) = 0;
	
	virtual void click() = 0;

	virtual void update() = 0;
};

};
#endif //MENUITEM_H