/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef MODEL_H
#define MODEL_H


#include "ClassInfo.h"

namespace VCF{

class ModelValidationListener;
/** @interface */

#define MODEL_CLASSID		"ED88C0AD-26AB-11d4-B539-00C04F0196DA"


class APPKIT_API Model : public Object {
public:    

	BEGIN_ABSTRACT_CLASSINFO(Model, "VCF::Model", "VCF::Object", MODEL_CLASSID)
	END_CLASSINFO(Model)

	Model(){
		
	};

	virtual ~Model(){};
    /**
     * Adds a validation listener to the model 
     */
    virtual void addModelValidationListener(ModelValidationListener * listener) = 0;

    /**
     * removes a validation listener from the model 
     */
    virtual void removeModelValidationListener(ModelValidationListener * listener) = 0;	   

    /**
     * validate the model. 
     * The implementation for this can vary widely, or even be nonexistant for model's that do not require validation.
     * The basic idea is to call all the listeners in the list , passing in a local variable to the
     * onModelValidate() methods of the listener's. The variable is initialized to true, and if it is
     * still true at the end of the listener iterations, then it is safe to apply the changes to the
     * model, other wise the changes are removed. 
     */
    virtual void validate() = 0;

    /**
     * clears out the model's data 
     */
    virtual void empty() = 0;

};

};
#endif //MODEL_H