/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef POINT_H
#define POINT_H

#include "Object.h"

namespace VCF{

class FRAMEWORK_API Point: public Object {
public:
    Point(const double & x, const double & y);
	Point();

    double m_x;
    double m_y;

	virtual void init();

	bool operator == ( const Point& pointToCompare )const{
		bool result = false;
		
		result = (this->m_x == pointToCompare.m_x) &&
			     (this->m_y == pointToCompare.m_y);

		return result;
	};

	bool closeTo( const double& x, const double& y, const double& tolerance=1.0 );
	bool closeTo( const Point& pt, const double& tolerance=1.0 );

	virtual String toString();
};

};
#endif //POINT_H