/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef RECT_H
#define RECT_H

#include "Object.h"
#include "Point.h"
#include "Stream.h"
#include "Persistable.h"
#include "ClassInfo.h"

namespace VCF{	

#define RECT_CLASSID		"ED88C096-26AB-11d4-B539-00C04F0196DA"

class FRAMEWORK_API Rect : public Object, public Persistable{
public:
	BEGIN_CLASSINFO(Rect, "VCF::Rect", "VCF::Object", RECT_CLASSID)	
	PROPERTY( double, "left", Rect::getLeft, Rect::setLeft, PROP_DOUBLE )
	PROPERTY( double, "top", Rect::getTop, Rect::setTop, PROP_DOUBLE )
	PROPERTY( double, "right", Rect::getRight, Rect::setRight, PROP_DOUBLE )
	PROPERTY( double, "bottom", Rect::getBottom, Rect::setBottom, PROP_DOUBLE )
	READONLY_PROPERTY( double, "width", Rect::getWidth, PROP_DOUBLE )
	READONLY_PROPERTY( double, "height", Rect::getHeight, PROP_DOUBLE )
	END_CLASSINFO(Rect)


    Rect( const double & left, const double & top, const double & right, const double & bottom );
	
	Rect( const Rect& rect );

	Rect();

    double m_bottom;
    double m_right;
    double m_top;
    double m_left;

    void inflate(const double & x, const double & y);

    bool containsPt( Point * point );

    double getWidth();

    double getHeight();

    void normalize();

    bool containsRect( Rect* rect );

	bool operator == ( const Rect& rectToCompare )const;

	void setRect( const double & left, const double & top, const double & right, const double & bottom );
	
	double getLeft(){
		return m_left;
	};

	void setLeft( const double& left ){
		m_left = left;
	};


	double getTop(){
		return m_top;
	};

	void setTop( const double& top ){
		m_top = top;
	};

	double getRight(){
		return m_right;
	};

	void setRight( const double& right ){
		m_right = right;
	};

	double getBottom(){
		return m_bottom;
	};

	void setBottom( const double& bottom ){
		m_bottom = bottom;
	};

	virtual String toString();

	/**
	*Write the object to the specified output stream
	*/
    virtual void saveToStream( OutputStream * stream );
	
	/**
	**Read the object from the specified input stream
	*/
    virtual void loadFromStream( InputStream * stream );

};

};

#endif //RECT_HH