/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

//Size.h

#ifndef _SIZE_H__
#define _SIZE_H__

#include "Object.h"

namespace VCF
{

class Size : public Object
{
public:

	Size( const double& w, const double& h ){
		this->init();
		m_width = w;
		m_height = h;
	}

	Size(){
		this->init();	
	};



;

	virtual ~Size(){};

	virtual void init(){
		m_width = 0.0;
		m_height = 0.0;
	};

	virtual String toString(){
		return Object::toString();
	};
	
	double m_width;
    double m_height;

	bool operator == ( const Size& sizeToCompare )const{
		bool result = false;
		
		result = (this->m_width == sizeToCompare.m_width) &&
			     (this->m_height == sizeToCompare.m_height);	

		return result;
	};

};

};


#endif