/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

#ifndef _TABPAGE_H__
#define _TABPAGE_H__

#include "VCF.h"
#include "Item.h"
#include "Control.h"


namespace VCF {

#define TABPAGE_CLASSID		"86F02172-3E7F-11d4-8EA7-00207811CFAB"

class APPKIT_API TabPage : public Item{

public:
	BEGIN_ABSTRACT_CLASSINFO(TabPage, "VCF::TabPage", "VCF::Object", TABPAGE_CLASSID)
	END_CLASSINFO(TabPage)
	TabPage(){
		
	};

	virtual ~TabPage(){};

	virtual void setPageName( const String& name ) = 0;

	virtual String getPageName() = 0;

	virtual Control* getPageComponent() = 0;

	virtual void setPageComponent( Control* component ) = 0;

	virtual ulong32 getPreferredHeight() = 0;	
};

}; //end of namespace VCF

#endif //_TABPAGE_H__