/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef TABBEDPAGES_H
#define TABBEDPAGES_H

#include "CustomControl.h"
#include "Container.h"
#include "TabModel.h"
#include "Basic3DBorder.h"

namespace VCF{

#define TABBEDPAGES_CLASSID		"4A9D66D6-3B26-11d4-B54C-00C04F0196DA"

class APPKIT_API TabbedPages : public CustomControl, public AbstractContainer{
public:
	BEGIN_CLASSINFO(TabbedPages, "VCF::TabbedPages", "VCF::CustomControl", TABBEDPAGES_CLASSID );
	END_CLASSINFO(TabbedPages);
	
	TabbedPages();

	virtual ~TabbedPages();

	void init();

	virtual void paint( GraphicsContext* context );

	TabModel* getModel();

	void setTabModel( TabModel* model );

	void onTabPageAdded( TabModelEvent* event );

	void onTabPageRemoved( TabModelEvent* event );

	void onTabPageSelected( TabModelEvent* event );

	TabPage* addNewPage( const String& caption );
	
	virtual void resizeChildren();

	virtual void mouseDown( MouseEvent* event );

	virtual void mouseMove( MouseEvent* event );

	virtual void mouseUp( MouseEvent* event );

	ulong32 getBorderWidth();

	void setBorderWidth( const ulong32& borderWidth );

private:
	TabModel* m_model;
	Rect m_tabAreaBounds;
	Basic3DBorder m_activePageBorder;
	ulong32 m_borderWidth;
};

};
#endif //TABBEDPAGES_H