/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */


#ifndef TABLEMODEL_H
#define TABLEMODEL_H

#include "Model.h"
#include "VCF.h"

namespace VCF{

class TableCellItem;

class TableModelListener;

typedef Enumerator<TableCellItem*> TableRowItemEnumerator;

#define TABLEMODEL_CLASSID     "BCA97CD1-6567-11d4-8EFF-00207811CFAB"

/**
*
*/
class APPKIT_API TableModel : public VCF::Model {    
public:
	BEGIN_ABSTRACT_CLASSINFO(TableModel, "VCF::TableModel", "VCF::Model", TABLEMODEL_CLASSID )
	END_CLASSINFO(TableModel)

	virtual ~TableModel(){};

    virtual void removeTableModelListener(TableModelListener * listener) = 0;

    virtual void addTableModelListener(TableModelListener * listener) = 0;

    virtual void addRow() = 0;

	virtual void insertRow( const uint32& afterRow ) = 0;

	virtual void deleteRow( const uint32& row ) = 0;

    virtual void addColumn() = 0;

	virtual void insertColumn( const uint32& afterColumn ) = 0;

	virtual void deleteColumn( const uint32& column ) = 0;

	virtual bool isCellEditable( const uint32& row, const uint32& column ) = 0;

	virtual TableCellItem* getItem( const uint32& row, const uint32& column ) = 0;
	
	virtual uint32 getRowCount() = 0;

	virtual uint32 getColumnCount() = 0;
	
	virtual TableRowItemEnumerator* getRowItemEnumerator( const uint32& row ) = 0;

	/**
	*this is overriden to provide TableModels derivations
	*control over what kind of item get created 
	*at any cell in the table.
	*@param uint32 - the row being created
	*/
	virtual void createCell( const uint32& row, const uint32& column, TableCellItem** createdCell ) = 0;
};

};
#endif //TABLEMODEL_H