/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 




#ifndef TEXTCONTROL_H
#define TEXTCONTROL_H

#include "Control.h"

namespace VCF{

class TextModel;

class TextPeer;

class DefaultTextModel;

#define TEXTCONTROL_CLASSID			"ED88C09E-26AB-11d4-B539-00C04F0196DA"

class APPKIT_API TextControl : public Control {
public:    
	BEGIN_CLASSINFO(TextControl, "VCF::TextControl", "VCF::Control", TEXTCONTROL_CLASSID )
	END_CLASSINFO(TextControl)

	TextControl();

	virtual ~TextControl();

	virtual void init();

	virtual void paint( GraphicsContext * context ){};

    void setTextModel( TextModel * model );

    TextModel* getTextModel();

	unsigned long getCaretPosition() throw (InvalidPeer);



private:    
    TextPeer * m_textPeer;
	TextModel* m_model;
};

};
#endif //TEXTCONTROL_H