/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef TOOLBAR_H
#define TOOLBAR_H

#include "Frame.h"
#include "Window.h"

namespace VCF{

class ToolbarButton;

/**
 *a floating frame that remains top level, has a close button, 
 *and a caption height that is shorter than normal. 
 */
class Toolbar : public CustomControl, public AbstractContainer {
public:
	Toolbar();

	virtual ~Toolbar();

	ToolbarDock* getDock();

	void setDock( ToolbarDock* dock );

	ulong32 getDockRow();

	void setDockRow( const ulong32& dockRow );

	bool isDocked();
	
	virtual void paint( GraphicsContext* context );

	bool isHandleVisible();

	void setHandleVisible( const bool& handleVisible );	

protected:
	void paintHandle( GraphicsContext* context );
	
private:
	std::vector<ToolbarButton*> m_toolbarBtns;

public:
	/**
	*inner class used by the Toolbar to create a Floating 
	*toolbar window when the Toolbar is dragged out of it's dock.
	*/
	class FloatingToolbar : public Window {
	public:
		FloatingToolbar();

		virtual ~FloatingToolbar();
	protected:
	private:
	};

};

};
#endif //TOOLBAR_H