/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef TREECONTROL_H
#define TREECONTROL_H

#include "Control.h"


namespace VCF{

class TreeModel;

class TreePeer;

class ImageList;

class TreeModelEvent;

class TreeModelHandler;

#define TREECONTROL_CLASSID			"ED88C09C-26AB-11d4-B539-00C04F0196DA"		
class APPKIT_API TreeControl : public VCF::Control {
public:
	BEGIN_CLASSINFO(TreeControl, "VCF::TreeControl", "VCF::Control", TREECONTROL_CLASSID )
	OBJECT_PROPERTY( TreeModel, "treeModel", TreeControl::getTreeModel, TreeControl::setTreeModel );
	END_CLASSINFO(TreeControl)

	TreeControl();
	
	virtual ~TreeControl();

    void setTreeModel(TreeModel * model);
    
	TreeModel* getTreeModel();

    void getImageList();

    void setImageList();

	virtual void paint( GraphicsContext * context );

	virtual void init();

	void onTreeRootNodeChanged( TreeModelEvent* event );
private:    
    TreePeer * m_treePeer;
	
	TreeModelHandler* m_treeHandler;

    ImageList* m_imageList;
	TreeModel* m_treeModel;	
};

};

#endif //TREECONTROL_H