/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */


#ifndef TREEITEM_H
#define TREEITEM_H

#include "Item.h"
#include "Enumerator.h"

namespace VCF{

class Color;

/** @interface */

#define TREEITEM_CLASSID		"3126B223-2819-11d4-B53A-00C04F0196DA"

class APPKIT_API TreeItem : public Item {
public:    

	BEGIN_ABSTRACT_CLASSINFO(TreeItem, "VCF::TreeItem", "VCF::Item", TREEITEM_CLASSID)
	OBJECT_COLLECTION_PROPERTY(TreeItem*, "children", TreeItem::getChildren, 
	               TreeItem::addChild, TreeItem::insertChild, TreeItem::deleteChild, TreeItem::deleteChild )
	PROPERTY( String, "name", TreeItem::getCaption, TreeItem::setCaption, PROP_STRING )
	END_CLASSINFO(TreeItem)

	TreeItem(){
		
	};

	virtual ~TreeItem(){};

    virtual Color* getTextColor() = 0;

    virtual void setTextColor(Color* color) = 0;

    virtual void setTextBold(const bool& bold) = 0;

    virtual bool getTextBold() = 0;

    virtual bool isLeaf() = 0;

	virtual bool isRoot() = 0;

    virtual TreeItem* getParent() = 0;
	
	virtual void setParent( TreeItem* parent ) = 0;

    virtual TreeItem* getNextChildNodeItem() = 0;

    virtual TreeItem* getPrevChildNodeItem() = 0;

    virtual String getCaption() = 0;

	virtual void setCaption( const String& caption ) = 0;

	virtual Enumerator<TreeItem*>* getChildren() = 0;

	virtual void addChild( TreeItem* child ) = 0;

	virtual void insertChild( const unsigned long& index, TreeItem* child ) = 0;
	
	virtual void deleteChild( TreeItem* child ) = 0;

	virtual void deleteChild( const unsigned long& index ) = 0;

	virtual void clearChildren() = 0;
};

};
#endif //TREEITEM_HEM_H