/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */



#ifndef TREEMODEL_H
#define TREEMODEL_H

#include "Model.h"

namespace VCF{

class TreeItem;

class TreeModelListener;

/** @interface */

#define TREEMODEL_CLASSID		"3126B225-2819-11d4-B53A-00C04F0196DA"
class APPKIT_API TreeModel : public Model {
public:
	
	BEGIN_ABSTRACT_CLASSINFO(TreeModel, "VCF::TreeModel", "VCF::Model", TREEMODEL_CLASSID)
	OBJECT_PROPERTY( TreeItem, "root", TreeModel::getRoot, TreeModel::setRoot );
	END_CLASSINFO(TreeModel)

	TreeModel(){
		
	};


	virtual ~TreeModel(){};

    virtual TreeItem* getRoot() = 0;

	virtual void setRoot( TreeItem* root ) = 0;

    virtual void addTreeModelListener( TreeModelListener * listener ) = 0;
    
	virtual void removeTreeModelListener( TreeModelListener * listener ) = 0;

    virtual void insertNodeItem( TreeItem * node, TreeItem * nodeToInsertAfter ) = 0;


    virtual void deleteNodeItem( TreeItem * nodeToDelete ) = 0;

    virtual void addNodeItem( TreeItem * node, TreeItem * nodeParent=NULL ) = 0;

    virtual void sort() = 0;
};

};

#endif //TREEMODEL_H