/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

#ifndef _VCFMATH_H__
#define _VCFMATH_H__

#include "FrameworkConfig.h"


namespace VCF {

#ifndef M_PI
	#define M_PI	3.1415926535897932384626433832795
#endif

class FRAMEWORK_API Math {

public:
	Math();

	virtual ~Math();

	/**
	*returns the radian value of theta, where theta is in degrees
	*/
	static double degreesToRadians( const double& theta ){
		return (M_PI * theta) / 180.0;
	}

	/**
	*returns the degee value of theta, where theta is in radians
	*/
	static double radiansToDegrees( const double& theta ){
		return (180.0 * theta) / M_PI;
	}
	
	static double Pi(){
		return M_PI;
	}	
	
};


}; //end of namespace VCF

#endif //_MATH_H__