/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */




#ifndef CLIPBOARD_H
#define CLIPBOARD_H
#include "Object.h"
#include "ClipboardListener.h"
#include "ClipboardEvent.h"
#include <vector>

namespace VCF{


class DataObject;
class ClipboardDataObject;
class ClipboardPeer;


class APPKIT_API Clipboard : public Object{
public:
	
	Clipboard();
	
	virtual ~Clipboard();

	/**
	*This macro creates a method for adding a listener to the Clipboard
	*/
	ADD_LISTENER(ClipboardListener);

	/**
	*This macro creates a method for removing a listener to the Clipboard
	*/
	REMOVE_LISTENER(ClipboardListener);

	NOTIFIER(ClipboardListener, onClipboardContentsChanged, ClipboardEvent);

	NOTIFIER(ClipboardListener, onClipboardItemCopied, ClipboardEvent);

	NOTIFIER(ClipboardListener, onClipboardItemPasted, ClipboardEvent);

    bool hasDataType(const unsigned long & dataType);

    void setContents( ClipboardDataObject* dataObject );
	ClipboardDataObject* getContents();

    void deleteDataObject( ClipboardDataObject* dataObject );

    


private:
    ClipboardDataObject* m_dataObject;
	/*
	*the listener list for the clipboard
	*/
	LISTENER_LIST(ClipboardListener);

    /**
     * @supplierCardinality 1
     */
    ClipboardPeer * m_clipboardPeer;
};

}
#endif //CLIPBOARD_H