/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */


#ifndef CLIPBOARDDATAOBJECT_H
#define CLIPBOARDDATAOBJECT_H

#include "Object.h"
#include "Enumerator.h"
#include "Persistable.h"
#include <vector>

namespace VCF{

class DataObjectPeer;

class DataType;

class APPKIT_API ClipboardDataObject : public Object, public Persistable{

public:    
	ClipboardDataObject( const char* dataToInitWith, const unsigned long& dataSize, const unsigned long& dataType );

	virtual ~ClipboardDataObject();	
	
	virtual void init();

	void addSupportedDataType( const unsigned long & dataType );

	bool isTypeSupported( const unsigned long & dataType );

	virtual void saveToStream( OutputStream * stream );

    virtual void loadFromStream( InputStream * stream );	
	
	VCF::Enumerator<DataType*> * getSupportedDataTypes();

private:
    /**
     * @supplierCardinality 1* 
     */
	std::vector<DataType*> m_types;
	VCF::EnumeratorContainer<std::vector<DataType*>, DataType* > m_typesContainer;
	
	char* m_rawData;	
	unsigned long m_dataSize;
};

};
#endif //CLIPBOARDDATAOBJECT_H