/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */


#ifndef DRAGEVENT_H
#define DRAGEVENT_H

#include "Event.h"
#include "ClipboardDataObject.h"


namespace VCF{

enum DragActionType{
	DRAG_ACTION_COPY=0,
	DRAG_ACTION_MOVE,
	DRAG_ACTION_LINK
};

class APPKIT_API DragEvent : public Event {
public:
	DragEvent( Object* source, VCF::ClipboardDataObject* data ):
		Event( source ){
		m_data = data;
	};
	
	DragEvent( Object* source, VCF::ClipboardDataObject* data, 
		       const unsigned long& keyMask, const unsigned long& buttonMask,
			   const DragActionType& action ):
		Event( source ){
		m_data = data;
		m_keyMask = keyMask;
		m_buttonMask = buttonMask;
		m_action = action;
	};

	virtual ~DragEvent(){};

	VCF::ClipboardDataObject* getDataObject();
    
	unsigned long getButtonMask();
	void setButtonMask( const unsigned long& buttonMask ); 

    unsigned long getKeyMask();
	void setKeyMask( const unsigned long& keyMask ); 
	
	/**
	*
	*/
	void setActionType( const DragActionType& action );
	/**
	*get the type of action the event represents
	*/
	DragActionType getAction();

private:    
    VCF::ClipboardDataObject* m_data;
	unsigned long m_keyMask;
    unsigned long m_buttonMask;
	DragActionType m_action;
};

}
#endif //DRAGEVENT_H