/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef DROPEVENT_H
#define DROPEVENT_H

#include "Event.h"
#include "Point.h"
#include "ClipboardDataObject.h"


namespace VCF{
/**
 * Drop event are fired when an object is dropped during a drag drop operation. 
 */
class APPKIT_API DropEvent : public Event {


public:
	
	DropEvent( Object* source, VCF::ClipboardDataObject* data ):
		Event( source ){
		m_data = data;
	 };
	
	virtual ~DropEvent(){};

    unsigned long getButtonMask();
	void setButtonMask( const unsigned long& buttonMask ); 

    unsigned long getKeyMask();
	void setKeyMask( const unsigned long& keyMask ); 

    VCF::ClipboardDataObject* getDataObject();

    Point* getDropPoint();

private:    
    unsigned long m_keyMask;
    unsigned long m_buttonMask;
    VCF::ClipboardDataObject * m_data;
    Point* m_dropPoint;
};

}
#endif //DROPEVENT_H