/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */


#ifndef DROPTARGET_H
#define DROPTARGET_H


#include "DropTargetListener.h"

namespace VCF{

class Control;

class DropTargetPeer;

class APPKIT_API DropTarget : public Object {
public:        

    void getSupportedActions();
	
    DropTarget( Control * component );

	virtual ~DropTarget();
	
	LISTENER_LIST(DropTargetListener);

	ADD_LISTENER(DropTargetListener);

	REMOVE_LISTENER(DropTargetListener);

	NOTIFIER(DropTargetListener, onDropTargetDraggingOver, DragEvent);

	NOTIFIER(DropTargetListener, onDropTargetDropped, DropEvent);

	NOTIFIER(DropTargetListener, onDropTargetLeft, DragEvent);

	NOTIFIER(DropTargetListener, onDropTargetEntered, DragEvent);

	virtual void processEvents( Event* event );

	DropTargetPeer* getDropTargetPeer();

private:
	DropTargetPeer* m_dropTargetPeer;
};

};
#endif //DROPTARGET_H