/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef DROPTARGETLISTENER_H
#define DROPTARGETLISTENER_H

#include "Listener.h"
#include "DragEvent.h"
#include "DropEvent.h"



namespace VCF
{
/** @interface */


#define DROPTARGET_EVENT_DRAGGING_OVER		CUSTOM_EVENT_TYPES + 303
#define DROPTARGET_EVENT_DROPPED			CUSTOM_EVENT_TYPES + 304
#define DROPTARGET_EVENT_LEFT				CUSTOM_EVENT_TYPES + 305
#define DROPTARGET_EVENT_ENTERED			CUSTOM_EVENT_TYPES + 306


class APPKIT_API DropTargetListener : public Listener {
public:    
	virtual ~DropTargetListener(){};
    virtual void onDropTargetDraggingOver( DragEvent* event ) = 0;

    virtual void onDropTargetDropped( DropEvent* event ) = 0;

    virtual void onDropTargetLeft( DragEvent* event ) = 0;

    virtual void onDropTargetEntered( DragEvent* event ) = 0;
};

typedef void (Object::* OnDragTargetEvent1)( DragEvent* event );
typedef void (Object::* OnDragTargetEvent2)( DropEvent* event );


class APPKIT_API DropTargetHandler : public DropTargetListener, public Object{
public:
	DropTargetHandler( Object* source ){
		m_source = source;

		m_dropTargetDraggingOver = NULL;
		m_dropTargetDropped = NULL;
		m_dropTargetLeft = NULL;
		m_dropTargetEntered = NULL;
	};

	virtual ~DropTargetHandler(){};

	virtual void onDropTargetDraggingOver( DragEvent* event ){
		if ( NULL != m_dropTargetDraggingOver ){
			(m_source->*m_dropTargetDraggingOver)( event );
		}
	};

    virtual void onDropTargetDropped( DropEvent* event ){
		if ( NULL != m_dropTargetDropped ){
			(m_source->*m_dropTargetDropped)( event );
		}
	};

    virtual void onDropTargetLeft( DragEvent* event ){
		if ( NULL != m_dropTargetLeft ){
			(m_source->*m_dropTargetLeft)( event );
		}
	};

    virtual void onDropTargetEntered( DragEvent* event ){
		if ( NULL != m_dropTargetEntered ){
			(m_source->*m_dropTargetEntered)( event );
		}
	};

	OnDragTargetEvent1 m_dropTargetDraggingOver;
	OnDragTargetEvent2 m_dropTargetDropped;
	OnDragTargetEvent1 m_dropTargetLeft;
	OnDragTargetEvent1 m_dropTargetEntered;
private:
	Object* m_source;

	

};

};
#endif //DROPTARGETLISTENER_H