/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

#ifndef _COMBOBOXLISTENER_H__
#define _COMBOBOXLISTENER_H__

#include "Listener.h"

namespace VCF {

class ItemEvent;

class APPKIT_API ComboBoxListener : public Listener{
public:
	virtual ~ComboBoxListener(){};

	virtual void onSelectionChange( ItemEvent* event ) = 0;

};


typedef void (Object::*OnComboBoxEvent)(ItemEvent* event);


class APPKIT_API ComboBoxAdapter : public Object, public ComboBoxListener {
public:
	ComboBoxAdapter( Object* source = NULL ){
		m_source = source;
		m_selectionChange = NULL;
	}

	virtual ~ComboBoxAdapter(){};

	virtual void onSelectionChange( ItemEvent* event ){
		if ( (NULL != m_source) && (NULL != m_selectionChange) ){
			(m_source->*m_selectionChange)( event );	
		}
	}

	OnComboBoxEvent m_selectionChange;
	Object* m_source;
};

}; //end of namespace VCF

#endif //_COMBOBOXLISTENER_H__