/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 




#ifndef COMPONENTEVENT_H
#define COMPONENTEVENT_H

#include "Event.h"
#include "Size.h"
#include "Point.h"

namespace VCF{


#define COMPONENT_EVENT_CREATED				CUSTOM_EVENT_TYPES + 403
#define COMPONENT_EVENT_DELETED				CUSTOM_EVENT_TYPES + 404

/**
*ComponentEvent are events generated by changes made to the component.
*Currently there are 2 types, one for the component being created, and
*one for component deletion.
*
*@version 1.0
*@author Jim Crafton
*/
class APPKIT_API ComponentEvent : public Event {
public:
	ComponentEvent( Object * source):
		Event( source ){
	};

	ComponentEvent( Object* source, const unsigned long& eventType ):
		Event( source, eventType ){
	};

	virtual ~ComponentEvent(){};

};

};
#endif //COMPONENTEVENT_H