/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef COMPONENTLISTENER_H
#define COMPONENTLISTENER_H

#include "Listener.h"
#include "ComponentEvent.h"

namespace VCF{
/** @interface */


class APPKIT_API ComponentListener : public VCF::Listener {
public:    
	virtual ~ComponentListener(){};

    virtual void onComponentCreated( ComponentEvent* event ) = 0;

    virtual void onComponentDeleted( ComponentEvent* event ) = 0;
};


typedef void (Object::* OnComponentEvent)( ComponentEvent* event );


class APPKIT_API ComponentHandler : public ComponentListener, public Object {
public:
	ComponentHandler( Object* source ){
		m_source = source;
		m_componentCreated = NULL;
		m_componentDeleted = NULL;
	};
	
	virtual ~ComponentHandler(){};

	virtual void onComponentCreated( ComponentEvent* event ){
		if ( NULL != m_componentCreated ){
			(m_source->*m_componentCreated)( event );
		}
	};

    virtual void onComponentDeleted( ComponentEvent* event ){
		if ( NULL != m_componentDeleted ){
			(m_source->*m_componentDeleted)( event );
		}
	};

	OnComponentEvent m_componentCreated;
	OnComponentEvent m_componentDeleted;
private:
	Object* m_source;
};

};

#endif //COMPONENTLISTENER_H