/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

// ImageListEvent.h

#if !defined(_IMAGELISTEVENT_H__)
#define _IMAGELISTEVENT_H__


#include "Event.h"

namespace VCF
{


#define IMAGELIST_CONST						1100

#define IMAGELIST_EVENT_WIDTH_CHANGED		CUSTOM_EVENT_TYPES + IMAGELIST_CONST + 1
#define IMAGELIST_EVENT_HEIGHT_CHANGED		CUSTOM_EVENT_TYPES + IMAGELIST_CONST + 2
#define IMAGELIST_EVENT_CREATED				CUSTOM_EVENT_TYPES + IMAGELIST_CONST + 3
#define IMAGELIST_EVENT_DESTROYED			CUSTOM_EVENT_TYPES + IMAGELIST_CONST + 4
#define IMAGELIST_EVENT_ITEM_ADDED			CUSTOM_EVENT_TYPES + IMAGELIST_CONST + 5
#define IMAGELIST_EVENT_ITEM_DELETED		CUSTOM_EVENT_TYPES + IMAGELIST_CONST + 6


class ImageListEvent : public Event  
{
public:
	
	ImageListEvent( Object * source);

	ImageListEvent( Object* source, const unsigned long& eventType );

	virtual ~ImageListEvent();
	
	
};

};

#endif 
