/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

// ItemEvent.h

#ifndef _ITEMEVENT_H__
#define _ITEMEVENT_H__


#include "Event.h"
#include "Point.h"

namespace VCF
{

class GraphicsContext;

#define ITEM_CONST						200

#define ITEM_EVENT_PAINT				CUSTOM_EVENT_TYPES + ITEM_CONST + 1
#define ITEM_EVENT_CHANGED				CUSTOM_EVENT_TYPES + ITEM_CONST + 2
#define ITEM_EVENT_SELECTED				CUSTOM_EVENT_TYPES + ITEM_CONST + 3
#define ITEM_EVENT_ADDED				CUSTOM_EVENT_TYPES + ITEM_CONST + 4
#define ITEM_EVENT_DELETED				CUSTOM_EVENT_TYPES + ITEM_CONST + 5
#define ITEM_EVENT_TEXT_CHANGED			CUSTOM_EVENT_TYPES + ITEM_CONST + 6

class APPKIT_API ItemEvent : public Event  
{
public:
	ItemEvent( Object* source );

	ItemEvent( Object* source, const unsigned long& eventType );
	
	ItemEvent( Object* source, GraphicsContext* context );

	virtual ~ItemEvent();

	GraphicsContext* getContext();

	/**
	*returns the point for this mouse event
	*/
	Point* getPoint();

	void setPoint( Point* point );

private:
	GraphicsContext* m_paintContext;
	Point m_point;
};

};

#endif 
