/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef ITEMLISTENER_H
#define ITEMLISTENER_H

#include "Listener.h"
#include "ItemEvent.h"

namespace VCF{

/** @interface */

class APPKIT_API ItemListener : public Listener {
public:    
	virtual ~ItemListener(){};

    virtual void onItemPaint( ItemEvent* event ) = 0;

    virtual void onItemChanged( ItemEvent* event ) = 0;

    virtual void onItemSelected( ItemEvent* event ) = 0;

	virtual void onItemAdded( ItemEvent* event ) = 0;
	
	virtual void onItemDeleted( ItemEvent* event ) = 0;
};


typedef void (Object::* OnItemEvent)( ItemEvent* event );

class APPKIT_API ItemHandler : public Object, public ItemListener {
public:
	ItemHandler( Object* source ){
		m_source = source;
		m_itemPaint = NULL;
		m_itemChanged = NULL;
		m_itemSelected = NULL;
		m_itemAdded = NULL;
		m_itemDeleted = NULL;
	};

	virtual ~ItemHandler(){};

	virtual void onItemPaint( ItemEvent* event ){
		if ( NULL != m_itemPaint ){
			(m_source->*m_itemPaint)( event );
		}
	};

    virtual void onItemChanged( ItemEvent* event ){
		if ( NULL != m_itemChanged ){
			(m_source->*m_itemChanged)( event );
		}
	};

    virtual void onItemSelected( ItemEvent* event ){
		if ( NULL != m_itemSelected ){
			(m_source->*m_itemSelected)( event );
		}
	};

	virtual void onItemAdded( ItemEvent* event ){
		if ( NULL != m_itemAdded ){
			(m_source->*m_itemAdded)( event );
		}
	};
		
	virtual void onItemDeleted( ItemEvent* event ){
		if ( NULL != m_itemDeleted ){
			(m_source->*m_itemDeleted)( event );
		}
	};


	OnItemEvent m_itemPaint;
	OnItemEvent m_itemChanged;
	OnItemEvent m_itemSelected;
	OnItemEvent m_itemAdded;
	OnItemEvent m_itemDeleted;
private:
	Object* m_source;
};

};
#endif //ITEMLISTENER_H