/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef KEYBOARDLISTENER_H
#define KEYBOARDLISTENER_H
#include "MouseListener.h"
#include "Listener.h"

namespace VCF{

class KeyboardEvent;

/**
*KeyboardListener
*/

class APPKIT_API KeyboardListener : public VCF::Listener {
public:    

    virtual void onKeyPressed( KeyboardEvent* event ) = 0;

    virtual void onKeyDown( KeyboardEvent* event ) = 0;

    virtual void onKeyUp( KeyboardEvent* event ) = 0;
};


typedef (Object::* OnKeyboardEvent)( KeyboardEvent* event );


class APPKIT_API KeyboardHandler : public KeyboardListener, public Object {
public:
	KeyboardHandler( Object* source ){
		m_source = source;

		m_keyPressed = NULL;
		m_keyDown = NULL;
		m_keyUp = NULL;
	};

	virtual ~KeyboardHandler(){};

	virtual void onKeyPressed( KeyboardEvent* event ){
		if ( NULL != m_keyPressed ){
			(m_source->*m_keyPressed)( event );
		}
	};

    virtual void onKeyDown( KeyboardEvent* event ){
		if ( NULL != m_keyDown ){
			(m_source->*m_keyDown)( event );
		}
	};

    virtual void onKeyUp( KeyboardEvent* event ){
		if ( NULL != m_keyUp ){
			(m_source->*m_keyUp)( event );
		}
	};

	OnKeyboardEvent m_keyPressed;
	OnKeyboardEvent m_keyDown;
	OnKeyboardEvent m_keyUp;

private:
	Object* m_source;
};

};
#endif //KEYBOARDLISTENER_H