/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

// ListModelEvent.h

#ifndef _LISTMODELEVENT_H__
#define _LISTMODELEVENT_H__


#include "Event.h"

namespace VCF
{

class ListItem;

#define LIST_MODEL_CONST				900

#define LIST_MODEL_CONTENTS_DELETED		CUSTOM_EVENT_TYPES + LIST_MODEL_CONST + 1
#define LIST_MODEL_ITEM_CHANGED			CUSTOM_EVENT_TYPES + LIST_MODEL_CONST + 2


class ListModelEvent : public Event  
{
public:
	ListModelEvent( Object* source );

	ListModelEvent( Object* source, const unsigned long& eventType );
	
	ListModelEvent( Object* source, ListItem* item );

	ListModelEvent( Object* source, const unsigned long& eventType, ListItem* item );

	virtual ~ListModelEvent();
	
	ListItem* getListItem();

	void setListItem( ListItem* item );
private:
	ListItem* m_listItem;
};

};

#endif 
