/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef LISTMODELLISTENER_H
#define LISTMODELLISTENER_H

#include "Object.h"
#include "Listener.h"
#include "ListModelEvent.h"

namespace VCF{
/** @interface */
class APPKIT_API ListModelListener : public VCF::Listener {
public:    

    virtual void onListModelContentsChanged( ListModelEvent* event ) = 0;

    virtual void onItemAdded( ListModelEvent* event ) = 0;

    virtual void onItemDeleted( ListModelEvent* event ) = 0;
};


typedef void (Object:: *OnListModelEvent)( ListModelEvent* event );


class APPKIT_API ListModelHandler : public Object, public ListModelListener {
public:
	ListModelHandler( Object* source ){
		m_source = source;
		m_listModelContentsChanged = NULL;
		m_itemAdded = NULL;
		m_itemDeleted = NULL;
	};

	virtual ~ListModelHandler(){};

	virtual void onListModelContentsChanged( ListModelEvent* event ){
		if ( NULL != m_listModelContentsChanged ){
			(m_source->*m_listModelContentsChanged)( event );	
		}
	};

    virtual void onItemAdded( ListModelEvent* event ){
		if ( NULL != m_itemAdded ){
			(m_source->*m_itemAdded)( event );	
		}
	};

    virtual void onItemDeleted( ListModelEvent* event ){
		if ( NULL != m_itemDeleted ){
			(m_source->*m_itemDeleted)( event );	
		}
	};

	OnListModelEvent m_listModelContentsChanged;
	OnListModelEvent m_itemAdded;
	OnListModelEvent m_itemDeleted;
private:
	Object* m_source;
};
};
#endif //LISTMODELLISTENER_H