/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef MOUSEEVENT_H
#define MOUSEEVENT_H

#include "Event.h"
#include "Point.h"

namespace VCF{

#define MOUSE_CONST						500

#define MOUSE_EVENT_DOWN				CUSTOM_EVENT_TYPES + MOUSE_CONST + 1
#define MOUSE_EVENT_MOVE				CUSTOM_EVENT_TYPES + MOUSE_CONST + 2
#define MOUSE_EVENT_UP					CUSTOM_EVENT_TYPES + MOUSE_CONST + 3
#define MOUSE_EVENT_CLICK				CUSTOM_EVENT_TYPES + MOUSE_CONST + 4
#define MOUSE_EVENT_DBLCLICK			CUSTOM_EVENT_TYPES + MOUSE_CONST + 5



class APPKIT_API MouseEvent : public Event {
public:
	MouseEvent( Object* source );

	MouseEvent( Object* source, const unsigned long& eventType );
	
	MouseEvent( Object* source, const unsigned long& eventType, const unsigned long& buttonMask, 
		        const unsigned long& keyMask, Point* point );	

	virtual ~MouseEvent(){};
	
	virtual void init();

	/**
	*returns the point for this mouse event
	*/
    Point* getPoint();

	void setPoint( Point* point );

    unsigned long getKeyMask();

    unsigned long getButtonMask();

	bool hasLeftButton();
	bool hasMiddleButton();
	bool hasRightButton();

	bool hasShiftKey();
	bool hasAltKey();
	bool hasControlKey();

private:
    unsigned long m_buttonMask;
    unsigned long m_keyMask;
    Point m_point;
};

};
#endif //MOUSEEVENT_H