/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef MOUSELISTENER_H
#define MOUSELISTENER_H


#include "Listener.h"
#include "MouseEvent.h"


namespace VCF{

/** @interface */

class APPKIT_API MouseListener : public VCF::Listener {
public:    

    virtual void onMouseDoubleClicked( MouseEvent* event ) = 0;

    virtual void onMouseClicked( MouseEvent* event ) = 0;

    virtual void onMouseMove( MouseEvent* event ) = 0;

    virtual void onMouseUp( MouseEvent* event ) = 0;

    virtual void onMouseDown( MouseEvent* event ) = 0;

};



typedef void(Object::* OnMouseEvent)( MouseEvent* event );
 


class APPKIT_API MouseHandler : public MouseListener, public Object {
public:
	MouseHandler( Object* source ){
		m_source = source;

		m_mouseDoubleClicked = NULL;	
		m_mouseClicked = NULL;	
		m_mouseMove = NULL;	
		m_mouseUp = NULL;	
		m_mouseDown = NULL;	
	};
	
	virtual ~MouseHandler(){};

	virtual void onMouseDoubleClicked( MouseEvent* event ){
		if ( NULL != m_mouseDoubleClicked ){
			(m_source->*m_mouseDoubleClicked)( event );			
		}
	};

    virtual void onMouseClicked( MouseEvent* event ){
		if ( NULL != m_mouseClicked ){
			(m_source->*m_mouseClicked)( event );
		}
	};

    virtual void onMouseMove( MouseEvent* event ){
		if ( NULL != m_mouseMove ){
			(m_source->*m_mouseMove)( event );
		}
	};

    virtual void onMouseUp( MouseEvent* event ){
		if ( NULL != m_mouseUp ){
			(m_source->*m_mouseUp)( event );
		}
	};

    virtual void onMouseDown( MouseEvent* event ){
		if ( NULL != m_mouseDown ){
			(m_source->*m_mouseDown)( event );
		}
	};

	OnMouseEvent m_mouseDoubleClicked;
	OnMouseEvent m_mouseClicked;
	OnMouseEvent m_mouseMove;
	OnMouseEvent m_mouseUp;
	OnMouseEvent m_mouseDown;

private:
	Object* m_source;

};


};
#endif //MOUSELISTENER_H