/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef PROPERTYLISTENER_H
#define PROPERTYLISTENER_H

#include "Listener.h"
#include "PropertyChangeEvent.h"


namespace VCF{
/** @interface */
class FRAMEWORK_API PropertyListener : public VCF::Listener {
public:
	virtual ~PropertyListener(){};

	/**
	*Classes implmenting this interface <b><i>MUST</i></b> throw PropertyChangeException
	*if they do not want the change to be processed.
	*/
    virtual void onPropertyChanged( PropertyChangeEvent * event ) = 0;
};

typedef void (Object::*OnPropertyEvent)( PropertyChangeEvent* event );

class  PropertyAdapter : public PropertyListener {
public:
	PropertyAdapter( Object* source=NULL, OnPropertyEvent propertyChanged=NULL ){
		m_source = source;
		m_propertyChanged = propertyChanged;
	}

	virtual void onPropertyChanged(PropertyChangeEvent * event){
		if ( (NULL != m_source) && (NULL != m_propertyChanged) ){
			(m_source->*m_propertyChanged)( event );
		}
	}

	Object* m_source;
	OnPropertyEvent m_propertyChanged;
};


};
#endif //PROPERTYLISTENER_H