//TabModelListener.h

#ifndef _TABMODEL_LISTENER_H__
#define _TABMODEL_LISTENER_H__

#include "TabModelEvent.h"
#include "Listener.h"

namespace VCF {

class APPKIT_API TabModelListener : public Listener {
public:
	virtual ~TabModelListener(){};

	virtual void onTabPageAdded( TabModelEvent* event ) = 0;

	virtual void onTabPageRemoved( TabModelEvent* event ) = 0;

	virtual void onTabPageSelected( TabModelEvent* event ) = 0;
};


typedef void (Object::*OnTabEvent)( TabModelEvent* event );

class APPKIT_API TabModelHandler : public Object, public TabModelListener {
public:
	TabModelHandler( Object* source ){
		m_source = source;
		m_tabPageAdded = NULL;
		m_tabPageRemoved = NULL;
	}

	virtual ~TabModelHandler(){};

	virtual void onTabPageAdded( TabModelEvent* event ){
		if ( (NULL != m_source) && (NULL != m_tabPageAdded) ){
			(m_source->*m_tabPageAdded)( event );
		}	
	};

	virtual void onTabPageRemoved( TabModelEvent* event ){
		if ( (NULL != m_source) && (NULL != m_tabPageRemoved) ){
			(m_source->*m_tabPageRemoved)( event );
		}	
	};

	virtual void onTabPageSelected( TabModelEvent* event ){
		if ( (NULL != m_source) && (NULL != m_tabPageSelected) ){
			(m_source->*m_tabPageSelected)( event );
		}
	};

	OnTabEvent m_tabPageAdded;
	OnTabEvent m_tabPageRemoved;
	OnTabEvent m_tabPageSelected;

private:
	Object* m_source;
};

};
#endif