/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef TABLEMODELLISTENER_H
#define TABLEMODELLISTENER_H
#include "Listener.h"


namespace VCF{

class TableModelEvent;

/** @interface */
class APPKIT_API TableModelListener : public VCF::Listener {
public:
	virtual	~TableModelListener(){};

	virtual void onChange( TableModelEvent* event ) = 0;
};

typedef void (Object::*OnTableChanged)( TableModelEvent* event );

class APPKIT_API TableModelAdapter : public Object, public TableModelListener{
public:
	TableModelAdapter( Object* source, OnTableChanged onTableChanged=NULL){
		m_tableChanged = onTableChanged;
		m_source = source;
	}

	virtual ~TableModelAdapter(){};

	virtual void onChange( TableModelEvent* event ){
		if ( (NULL != m_source) && (NULL != m_tableChanged) ){
			(m_source->*m_tableChanged)( event );
		}	
	}
	
	OnTableChanged m_tableChanged;
	Object* m_source;
};

};
#endif //TABLEMODELLISTENER_H