/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef TEXTMODELLISTENER_H
#define TEXTMODELLISTENER_H

#include "Listener.h"
#include "TextEvent.h"

namespace VCF{

/** @interface */
class APPKIT_API TextModelListener : public VCF::Listener {
public:    

	virtual ~TextModelListener(){};

    virtual void onTextChanged( TextEvent* event ) = 0;
};


typedef void (Object::* OnTextEvent)( TextEvent* event );


class APPKIT_API TextModelHandler : public TextModelListener {
public:
	TextModelHandler( Object* source ){
		m_source = source;
		m_textChanged = NULL;
	};

	virtual ~TextModelHandler(){};

	virtual void onTextChanged( TextEvent* event ){
		if ( NULL != m_textChanged ){
			(m_source->*m_textChanged)( event );
		}
	};


	OnTextEvent m_textChanged;
private:
	Object* m_source;
};

};

#endif //TEXTMODELLISTENER_H