/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef TREEMODELLISTENER_H
#define TREEMODELLISTENER_H

#include "Object.h"
#include "Listener.h"
#include "TreeModelEvent.h"


namespace VCF{
/** @interface */
class APPKIT_API TreeModelListener : public VCF::Listener {
public:
	virtual ~TreeModelListener(){};

	virtual void onRootNodeChanged( TreeModelEvent* event ) = 0;

	virtual void onNodeAdded( TreeModelEvent* event ) = 0;
};



typedef void (Object:: *OnTreeModelEvent)( TreeModelEvent* event );


class APPKIT_API TreeModelHandler : public Object, public TreeModelListener {
public:
	TreeModelHandler ( Object* source ){
		m_source = source;
		m_rootNodeChanged = NULL;
		m_nodeAdded = NULL;
	};

	virtual ~TreeModelHandler(){};
	
	virtual void onRootNodeChanged( TreeModelEvent* event ){
		if ( NULL != m_rootNodeChanged ){
			(m_source->*m_rootNodeChanged)( event );
		}
	};

	virtual void onNodeAdded( TreeModelEvent* event ){
		if ( NULL != m_nodeAdded ){
			(m_source->*m_nodeAdded)( event );
		}
	};

	OnTreeModelEvent m_rootNodeChanged;
	OnTreeModelEvent m_nodeAdded;
private:
	Object* m_source;
};

};
#endif //TREEMODELLISTENER_H