/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef WINDOWEVENT_H
#define WINDOWEVENT_H

#include "Event.h"

namespace VCF{

#define WINDOW_CONST					600

#define WINDOW_EVENT_CLOSE				CUSTOM_EVENT_TYPES + WINDOW_CONST + 1
#define WINDOW_EVENT_RESTORE			CUSTOM_EVENT_TYPES + WINDOW_CONST + 2
#define WINDOW_EVENT_MAXIMIZE			CUSTOM_EVENT_TYPES + WINDOW_CONST + 3
#define WINDOW_EVENT_MINIMIZE			CUSTOM_EVENT_TYPES + WINDOW_CONST + 4

class APPKIT_API WindowEvent : public VCF::Event {
public:
	WindowEvent( Object* source );

	WindowEvent( Object* source, const unsigned long& eventType );
	
	virtual ~WindowEvent(){};

	/**
	*returns whether or not the window can close. 
	*Windows which are in their closing methods should not close 
	*if the flag has been set to false
	*/
	bool isOkToClose();

	/**
	*sets the event m_okToClose flag
	*/
	void setOkToClose( const bool& okToClose );
private:
	bool m_okToClose;
};

};
#endif //WINDOWEVENT_H