/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef WINDOWLISTENER_H
#define WINDOWLISTENER_H


#include "Listener.h"
#include "WindowEvent.h"

namespace VCF{

/** @interface */
class APPKIT_API WindowListener : public VCF::Listener {
public:
    /**
     * Objects that handle this event must return true if it is OK to close the window, or False if it is not. 
     */
    virtual void onWindowClose( WindowEvent* event ) = 0;

    virtual void onWindowRestore( WindowEvent* event ) = 0;

    virtual void onWindowMaximize( WindowEvent* event ) = 0;

    virtual void onWindowMinimize( WindowEvent* event ) = 0;

private:
};


typedef (Object::* OnWindowEvent)( WindowEvent* event );



class APPKIT_API WindowHandler : public WindowListener, public Object {
public:
	WindowHandler( Object* source ){
		m_source = source;
		m_windowClose = NULL;
		m_windowRestore = NULL;
		m_windowMaximize = NULL;
		m_windowMinimize = NULL;
	};

	virtual ~WindowHandler(){};

	virtual void onWindowClose( WindowEvent* event ){
		if ( NULL != m_windowClose ){
			(m_source->*m_windowClose)( event );			
		}
	};

    virtual void onWindowRestore( WindowEvent* event ){
		if ( NULL != m_windowRestore ){
			(m_source->*m_windowRestore)( event );			
		}
	};

    virtual void onWindowMaximize( WindowEvent* event ){
		if ( NULL != m_windowMaximize ){
			(m_source->*m_windowMaximize)( event );			
		}
	};	

    virtual void onWindowMinimize( WindowEvent* event ){
		if ( NULL != m_windowMinimize ){
			(m_source->*m_windowMinimize)( event );			
		}
	};

	OnWindowEvent m_windowClose;
	OnWindowEvent m_windowRestore;
	OnWindowEvent m_windowMaximize;
	OnWindowEvent m_windowMinimize;

private:
	Object* m_source;
};

};
#endif //WINDOWLISTENER_H