/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 



#ifndef APPLICATIONEXCEPTION_H
#define APPLICATIONEXCEPTION_H


#include "BasicException.h"


namespace VCF
{
/**
*Application level exceptions
*
*@version 1.0
*@author Jim Crafton
*/
class APPKIT_API ApplicationException : public VCF::BasicException {
public:
	ApplicationException( const VCF::String & message ):
		BasicException( message ){};

	ApplicationException():
		BasicException( APPLICATION_EXCEPTION ){};

	ApplicationException( const VCF::String & message, const int lineNumber ):
		VCF::BasicException(message, lineNumber){};

	virtual ~ApplicationException(){};
};

};

#endif //APPLICATIONEXCEPTION_H
_H
