/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 




#ifndef BADIMAGEBITSEXCEPTION_H
#define BADIMAGEBITSEXCEPTION_H

#include "BasicException.h"


namespace VCF
{

/**
*This exception should be thrown when pointer access to the image's 
*pixels has become corrupt. This is almost certainly an unrecoverable
*error.
*
*@version 1.0
*@author Jim Crafton
*/
class BadImageBitsException : public VCF::BasicException {
public:

	BadImageBitsException( const VCF::String & message ):
		BasicException( message ){};

	BadImageBitsException():
		BasicException( BAD_IMAGE_BITS_EXCEPTION ){};

	BadImageBitsException( const VCF::String & message, const int lineNumber ):
		VCF::BasicException(message, lineNumber){};

	virtual ~BadImageBitsException(){};
};

};

#endif //BADIMAGEBITSEXCEPTION_HON_H