/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 
//
//ErrorStrings.h

#ifndef _ERROR_STRINGS_H__
#define _ERROR_STRINGS_H__

namespace VCF
{

#ifdef _DEBUG
#define MAKE_ERROR_MSG(message)			String(message) +	String("\nException in file: ") + String( __FILE__ )
#else
#define MAKE_ERROR_MSG(message)			String(message)
#endif

#define NO_TOOLKIT_ERROR				"Error in VCF Framework: No toolkit found."
#define NO_GFX_TOOLKIT_ERROR			"Error in VCF Framework: No Graphics toolkit found."
#define CANT_GET_INTERFACE_ERROR		"Error retreiving interface. COM can't find or can't instantiate the requested Interface."
#define NO_PEER							"Attempt to use an invalid Peer."
#define CLASS_NOT_FOUND					"Requested class not found in the Framework Class Registry."
#define INVALID_POINTER_ERROR			"Invalid pointer found. The pointer is either null or pointing to bad memory."
#define APPLICATION_EXCEPTION			"Application error."
#define BAD_COMPONENTSTATE_EXCEPTION	"The component is in an invalid state."
#define BAD_ITEMSTATE_EXCEPTION			"The item is in an invalid state."
#define BAD_IMAGE_BITS_EXCEPTION		"The image's pixel bits are corrupt or the pointer to them is referencing bad memory."
#define BAD_MODEL_STATE_EXCEPTION		"The model's is corrupt or incorrect."	
#define OUT_OF_BOUNDS_EXCEPTION			"The requested index is outside of the coleections bounds."					

#define INVALID_IMAGE					"This is image is invalid."

#define CANT_ACCESS_FILE				"Error attempting to access file: "				
#define CANT_WRITE_TO_FILE				"Error attempting to write to file: "
#define PROPERTY_CHANGE_BAD				"The requested value(s) cannot be set on the given object."

#define RUNTIME_ERROR					"A System runtime exception has occurred. Doh - you probably already knew that !"

};

#endif
