/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 


#ifndef NOGRAPHICSTOOLKITFOUNDEXCEPTION_H
#define NOGRAPHICSTOOLKITFOUNDEXCEPTION_H

#include "BasicException.h"

namespace VCF {

class NoGraphicsToolkitFoundException : public VCF::BasicException {
public:
	NoGraphicsToolkitFoundException( const VCF::String & message ):
	  VCF::BasicException( message ){};

	NoGraphicsToolkitFoundException():
		VCF::BasicException( NO_GFX_TOOLKIT_ERROR ){};

	NoGraphicsToolkitFoundException( const VCF::String & message, const int lineNumber ):
		VCF::BasicException(message, lineNumber){};

	virtual ~NoGraphicsToolkitFoundException(){};

};

};

#endif //NOGRAPHICSTOOLKITFOUNDEXCEPTION_H