/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef BASICSTROKE_H
#define BASICSTROKE_H

#include "VCF.h"
#include "Stroke.h"
#include "Object.h"
#include "Color.h"
#include "StrokeState.h"


namespace VCF{

class GraphicsContext;

class GRAPHICSKIT_API BasicStroke : public VCF::Object, public VCF::Stroke {
public:
	BasicStroke();
	
	virtual ~BasicStroke();
	
	void init();

	virtual void setContext( GraphicsContext* context );

    virtual void render( Path * path );

	double getWidth();

	void setWidth( double width );

	Color* getColor();

	void setColor( Color* color );

private:
	double m_width;
	Color m_color;
	GraphicsContext* m_context;
	StrokeState m_strokeState;

	void line( const double& x1, const double& y1,
		       const double& x2, const double& y2 );
};

}
#endif //BASICSTROKE_H