/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef COMPOSITION_H
#define COMPOSITION_H

#include "VCF.h"

namespace VCF{
/** A Composition is a collection of graphics elements that can rendered as a group to some graphics context. 
 *   Rendering to the context requires getting a bitmap to use and then rendering the composition contents to the bitmap. 
 *    Once this is done the bitmap contents are rendered to the compositions graphics context.
 * @interface */
class GRAPHICSKIT_API Composition {
public:    

    virtual void addElement() = 0;

    virtual void render() = 0;

    virtual void removeElement() = 0;
};

}
#endif //COMPOSITION_H