/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 


//ImageLoader.h

#ifndef _IMAGE_LOADER_H__
#define _IMAGE_LOADER_H__

#include "VCF.h"
#include "Image.h"

namespace VCF
{

/**
*The ImageLoader interface provides a means to load up images into a generic Bitmap.
*Examples are JPEG ImageLoaders, GIF, BMP, etc ImageLoaders.
*
*@version 1.0
*@author Jim Crafton
*/
/*@interface*/
class GRAPHICSKIT_API ImageLoader {
public:
	virtual ~ImageLoader(){};

	virtual Image* loadImageFromFile( const String& fileName )=0;
	
	virtual void saveImageToFile( const String& fileName, Image* image )=0;
};

};

	
#endif