/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

#ifndef _OPENGLCONTEXT_H__
#define _OPENGLCONTEXT_H__
#include "VCF.h"
#include "GraphicsContext.h"


namespace VCF {

class GRAPHICSKIT_API OpenGLPeer;

class GRAPHICSKIT_API OpenGLContext : public GraphicsContext{

public:
	/**
	*Creates a new blank graphics context of the specified width and height
	*/
	OpenGLContext( const unsigned long& width, const unsigned long& height );
	
	/**
	*Creates a context based on the component. The context is attached to the component
	*for the duration of it's lifetime.
	*/
	//OpenGLContext( Control* control );

	/**
	*Create a new context based on a context ID. See ContextPeer getContextID()
	*Doing this should caryy over any of the current settings of the context that the contextID represents.
	*/
	OpenGLContext( const long& contextID );

	virtual ~OpenGLContext();

	void initGL();

	void init();

	void swapBuffers();
private:
	OpenGLPeer* m_glPeer;
};

}; //end of namespace VCF

#endif //_OPENGLCONTEXT_H__