/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */


#ifndef PATH_H
#define PATH_H

#include "VCF.h"
#include "Rect.h"
#include "PathEnumerator.h"

namespace VCF{

class GRAPHICSKIT_API Matrix2D;



class GRAPHICSKIT_API Path : public Interface{
public:   
	virtual ~Path(){};

    virtual bool contains(Rect * rect) = 0;

    virtual bool contains(Point * pt) = 0;

    virtual bool intersects(Point* pt) = 0;

    virtual bool intersects(Rect* rect) = 0;

    virtual Rect* getBounds() = 0;

    virtual PathEnumerator* getPathEnumerator( Matrix2D* transform ) = 0;

};


/**
*utility to make working with path points easier
*/
class GRAPHICSKIT_API PathPoint {
public:
	PathPoint();

	PathPoint( double x, double y, PathEnumerator::SegmentType type ){
		m_type = type;
		m_point.m_x = x;
		m_point.m_y = y;
	}

	PathPoint( Point* pt, PathEnumerator::SegmentType type ){
		m_type = type;
		m_point.m_x = pt->m_x;
		m_point.m_y = pt->m_y;
	}

	PathPoint( const Point& pt, PathEnumerator::SegmentType type ){
		m_type = type;
		m_point.m_x = pt.m_x;
		m_point.m_y = pt.m_y;
	}

	PathPoint( const PathPoint& pt ){
		m_point.m_x = pt.m_point.m_x;
		m_point.m_y = pt.m_point.m_y;
		m_type = pt.m_type;
	};

	virtual ~PathPoint(){};

	operator=( const PathPoint& pt ){
		m_point.m_x = pt.m_point.m_x;
		m_point.m_y = pt.m_point.m_y;
		m_type = pt.m_type;
	};

	bool operator==( const PathPoint& pt )const {
		return (m_point == pt.m_point) &&
			   (m_type == pt.m_type);
	};

	Point m_point;
	PathEnumerator::SegmentType m_type;
};


};
#endif //PATH_H