/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

#ifndef _PIXELBUFFER_H__
#define _PIXELBUFFER_H__

#include "VCF.h"

namespace VCF {

enum PixelFormat{
	PF_RGB = 0
};

class GRAPHICSKIT_API PixelBuffer {

public:
	PixelBuffer( const int32& width, const int32& height, 
		         const int32& rowstride, const bool hasAlpha=true ){};
	
	PixelBuffer( const PixelBuffer& pixBufferToCopy );

	virtual ~PixelBuffer(){};

	virtual void destroyNotify( void* funcData, void* data );
private:
	PixelFormat m_format;
	int32 m_numChannels;
	bool m_hasAlpha;
	int32 m_bitsPerSample;
	
	uchar* m_pixels;

	int32 m_width;
	int32 m_height;
	int32 m_rowStride;
	void* m_destroyData;
	
};

}; //end of namespace VCF

#endif //_PIXELBUFFER_H__