/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#ifndef POLYGON_H
#define POLYGON_H

#include "Object.h"
#include "Path.h"
#include "Matrix2D.h"
#include <vector>

namespace VCF{


class GRAPHICSKIT_API Polygon : public VCF::Object, public VCF::Path{
public:
	Polygon();
	
	virtual ~Polygon();
	
	virtual bool contains(Rect * rect);

    virtual bool contains(Point * pt);

    virtual bool intersects(Point* pt);

    virtual bool intersects(Rect* rect);

    virtual Rect* getBounds();

    virtual PathEnumerator* getPathEnumerator( Matrix2D* transform );

	void lineTo( const double& x, const double& y );

	void moveTo( const double& x, const double& y );
	
	void close();

	void clear();
protected:	
	class GRAPHICSKIT_API PolyPathEnumerator : public Object, public PathEnumerator {
	public:
		PolyPathEnumerator( Polygon* source, Matrix2D* matrix );
		
		virtual ~PolyPathEnumerator();
		
		virtual WindingType getWindingRule();

		bool hasMoreSegments();

		void next();
		
		virtual ulong32 getPointCount();
		
		virtual SegmentType getSegment( Point* points );

		virtual Enumerator<Point*>* flattenPoints();		

		virtual Rect* getBounds();
	private:
		Polygon* m_source;
		std::vector<PathPoint*> m_transformedPoints;
		std::vector<PathPoint*>::iterator m_pathIterator;	
		Rect m_bounds;
	};

	friend class GRAPHICSKIT_API PolyPathEnumerator;
	Rect m_bounds;
	ulong32 m_currentMoveToIndex;
	std::vector<PathPoint*> m_points;	
	Polygon::PolyPathEnumerator* m_pathEnumerator;
};

};
#endif //POLYGON_H