/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

#ifndef _LIBRARYPEER_H__
#define _LIBRARYPEER_H__


namespace VCF {

class FRAMEWORK_API LibraryPeer {

public:

	virtual ~LibraryPeer(){};

	/**
	*loads a dynamic library 
	*/
	virtual void load( const String& libraryFilename ) = 0;

	/**
	*returns a pointer to the function named functionName.
	*@param String the name of the function to get a pointer to
	*@return void* a pointer to the function. Must be typcasted into
	*a valid function pointer on the caller's side.
	*Throws RuntimeException if a failure to load the library occurs
	*/
	virtual void* getFunction( const String& functionName ) = 0;

	virtual void unload() = 0;

};

}; //end of namespace VCF

#endif //_LIBRARYPEER_H__