/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

#ifndef _REGISTRYPEER_H__
#define _REGISTRYPEER_H__

#include "VCF.h"


namespace VCF {



class FRAMEWORK_API RegistryPeer {
public:
	virtual ~RegistryPeer(){};

	virtual void setRoot( const RegistryKeyType& rootKey ) = 0;
	
	virtual RegistryKeyType getRoot() = 0;

	virtual bool openKey( const String& keyname, const bool& createIfNonExistant ) = 0;

	virtual bool setValue( const String& value, const String& valuename ) = 0; 

	virtual bool setValue( const uint32& value, const String& valuename ) = 0; 
	
	virtual bool setValue( const bool& value, const String& valuename ) = 0; 

	virtual bool setValue( void* dataBuffer, const uint32& dataBufferSize, const String& valuename ) = 0; 

	virtual String getStringValue( const String& valuename ) = 0;

	virtual uint32 getIntValue( const String& valuename ) = 0;

	virtual bool getBoolValue( const String& valuename ) = 0;

	virtual void getDataBufValue( const String& valuename, uint32& dataBufferSize, void** dataBuffer ) = 0;

	virtual Enumerator<String>* getKeyNames() = 0;

	virtual Enumerator<RegistryValueInfo*>* getValues() = 0;

	virtual String getCurrentKey() = 0;
};

}; //end of namespace VCF

#endif //_REGISTRYPEER_H__