/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 



#ifndef SCROLLBARPEER_H
#define SCROLLBARPEER_H


#include "ControlPeer.h"

namespace VCF{
/** @interface */
class APPKIT_API ScrollbarPeer : public VCF::ControlPeer {
public:    

    virtual double getPosition() = 0;

    virtual void setPosition(const double& position ) = 0;

    virtual void setMax(const double& max ) = 0;

    virtual double getMax() = 0;

    virtual double getMin() = 0;

    virtual void setMin( const double& min ) = 0;

    virtual void getPageSize() = 0;

    virtual void setPageSize() = 0;

    virtual void getOrientation() = 0;

    virtual void setOrientation() = 0;
};

}
#endif //SCROLLBARPEER_H