//SimpleDataObjectImplementer.h

#ifndef _SIMPLEDATAOBJECTIMPLEMENTER_H__
#define _SIMPLEDATAOBJECTIMPLEMENTER_H__


#include "DataObjectImplementer.h"
#include "DataObject.h"



namespace VCF
{


class SimpleDataObjectImplementer : public DataObjectImplementer  
{
public:
	SimpleDataObjectImplementer();
	virtual ~SimpleDataObjectImplementer();

	/**
    * Adds a new data type that the dataobject supports. 
	*/
    virtual void addSupportedData( const unsigned long & dataType, ClipboardDataObject* data )=0;

	virtual ClipboardDataObject* getSupportedData( const unsigned long & dataType )=0;

    /**
     * is the data type passed in supported by the data object ?
     */
    virtual bool isTypeSupported( const unsigned long & dataType )=0;
	

private:
	ClipboardDataObject* m_clipboardDataObject;
	VCFCOM::DataObject* m_dataObject;
};

};

#endif 
