/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

// Win32Application

#ifndef _WIN32APPLICATION_H__
#define _WIN32APPLICATION_H__


#include "Object.h"
#include "ApplicationPeer.h"
#include "Win32ResourceBundle.h"

namespace VCF
{



class APPKIT_API Win32Application : public Object, public ApplicationPeer  
{
public:
	Win32Application();
	virtual ~Win32Application();

	virtual bool initApp( const std::vector<VCF::String>& appCmdLine );

	virtual void terminateApp(); 

	virtual VCF::Application* getApplication();

	virtual void setApplication( VCF::Application* application );
	
	virtual ResourceBundle* getResourceBundle();

	virtual String getFileName();

	virtual void run();

	virtual String getCurrentDirectory();

	virtual void setCurrentDirectory( const String& currentDirectory );
private:
	VCF::Application* m_app;
	Win32ResourceBundle* m_resBundle;
};

};
#endif 
