/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 
// Win32DropTargetPeer.h

#ifndef _WIN32DROPTARGETPEER_H__
#define _WIN32DROPTARGETPEER_H__

#include "Object.h"
#include "DropTargetPeer.h"
#include "COMDropTarget.h"

namespace VCF {


class APPKIT_API Win32DropTargetPeer :	public DropTargetPeer, public Object  {
public:
	Win32DropTargetPeer();

	virtual ~Win32DropTargetPeer();

	virtual void registerTarget( Control* control );

	virtual void unregisterTarget( Control* control );
	
	virtual DropTarget* getDropTarget();

	virtual void setDropTarget( DropTarget* dropTarget );

private:
	DropTarget* m_dropTarget;

	VCFCOM::DropTarget* m_comDropTarget;

};


};

#endif // _WIN32DROPTARGETPEER_H__
