/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

#ifndef _WIN32FILEPEER_H__
#define _WIN32FILEPEER_H__


#include "Object.h"
#include "FilePeer.h"
#include "Win32Peer.h"

namespace VCF {

class FRAMEWORK_API Win32FilePeer : public Object, public FilePeer{

public:
	Win32FilePeer( const String& fileName="" );

	virtual ~Win32FilePeer();

	virtual void remove();

	/**
	*creates a new file
	*/
	virtual void create();


	/**
	*returns the size of the file in bytes
	*/
	virtual uint32 getSize();

	virtual String getName(){
		return m_filename;
	};

	virtual void setName( const String& fileName );
private:
	String m_filename;
	HANDLE m_fileHandle;
};

}; //end of namespace VCF

#endif //_WIN32FILEPEER_H__