/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

// Win32FileStream.h

#ifndef _WIN32FILESTREAM_H__
#define _WIN32FILESTREAM_H__

#include "VCFString.h"
#include "FileStreamPeer.h"
#include "Win32Peer.h"

namespace VCF
{

class FRAMEWORK_API Win32FileStream : public FileStreamPeer  
{
public:
	Win32FileStream( const String& filename, const FileStreamAccessType& accessType );	

	virtual ~Win32FileStream();
	
	virtual void seek( const unsigned long& offset, const SeekType& offsetFrom );

	virtual unsigned long getSize();

	virtual void read( char* bytesToRead, unsigned long sizeOfBytes );

	virtual void write( char* bytesToWrite, unsigned long sizeOfBytes );

	virtual char* getBuffer();
private:
	HANDLE m_fileHandle;
	VCF::String m_filename;
	DWORD translateAccessType( const FileStreamAccessType& accessType );
	DWORD translateAccessTypeToCreationType( const FileStreamAccessType& accessType );
	DWORD translateSeekTypeToMoveType( const SeekType& offsetFrom );
};


};

#endif
