/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

// Win32FontDialog.h

#ifndef _WIN32FONTDIALOG_H__
#define _WIN32FONTDIALOG_H__


#include "Object.h"
#include "CommonDialogPeer.h"
#include "Win32Peer.h"
#include "Font.h"

namespace VCF {

class Control;

class Control;

class APPKIT_API Win32FontDialog : public Object, public CommonFontDialogPeer  {
public:
	Win32FontDialog( Control* owner );

	virtual ~Win32FontDialog();

	virtual void setTitle( const String& title );

	virtual bool execute();

	virtual Font* getSelectedFont();

	virtual void setSelectedFont( Font* selectedFont );

private:
	Font m_font;
	Control* m_owner;
};


};
#endif // _WIN32FONTDIALOG_H__
