/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

// Win32MenuBar.h

#ifndef _WIN32MENUBAR_H__
#define _WIN32MENUBAR_H__


#include "MenuBarPeer.h"
#include "Win32Peer.h"
#include "MenuBar.h"

namespace VCF
{

class APPKIT_API Win32MenuBar : public MenuBarPeer  
{
public:
	Win32MenuBar( MenuBar* menuBar );

	virtual ~Win32MenuBar();

	virtual void setFrame( Frame* frame );

	virtual void update();

	virtual void setMenuItems( MenuItem* item );
private:	
	MenuItem* m_menuRoot;
	Frame* m_frame;

};

};

#endif 
