/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

#ifndef _WIN32POPUPMENU_H__
#define _WIN32POPUPMENU_H__

#include "Object.h"
#include "PopupMenuPeer.h"

namespace VCF {

class Point;

class Control;

class PopupMenu;

class Win32PopupMenu : public PopupMenuPeer, public Object {

public:
	Win32PopupMenu( PopupMenu* popupMenu );

	virtual ~Win32PopupMenu();

	virtual void setControl( Control* control );

	virtual void popup( Point* pt );
private:
	Control* m_control;
	PopupMenu* m_popupMenu;
};

}; //end of namespace VCF

#endif //_WIN32POPUPMENU_H__