/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

// Win32Peer.h

#ifndef _WIN32THREAD_H__
#define _WIN32THREAD_H__

#include "ThreadPeer.h"
#include "Win32Peer.h"

namespace VCF
{


class FRAMEWORK_API Win32Thread : public ThreadPeer  
{
public:
	Win32Thread( );	

	virtual ~Win32Thread();

	virtual bool start();

	virtual bool stop( int32 waitMillisec, bool forcekill, uint32 * pThreadExitCode );
	
	virtual void sleep( uint32 msec );

	virtual	bool checkForStop();
};



class FRAMEWORK_API Win32ThreadMutex : public ThreadMutexPeer  
{
public:
	Win32ThreadMutex( );	

	virtual ~Win32ThreadMutex();

	virtual ThreadMutexAcquire acquire( int32 msec, bool* pStopNow );

	virtual bool release();
};



class FRAMEWORK_API Win32ThreadSignal : public ThreadSignalPeer
{
public:
	Win32ThreadSignal( );	

	virtual ~Win32ThreadSignal();

	virtual bool setSignalState( bool signalState );

	virtual ThreadSignalState waitOnSignalState( bool desiredState, int32 msec, bool* pStopNow );
};


};
#endif
