/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

//FileStreamPeer.h


#ifndef _FILESTREAMPEER_H__
#define _FILESTREAMPEER_H__

#include "Stream.h"

namespace VCF
{

/**
*@interface FileStreamPeer
*Basic File Stream interface to wrap native file IO OS calls.
*Under Win32 this will involve calls to ReadFile() and WriteFile,
*among others.
*
*@author Jim Crafton
*@version 1.0
*/
class FRAMEWORK_API FileStreamPeer {
public:
	virtual ~FileStreamPeer(){};

	virtual void seek(const unsigned long& offset, const SeekType& offsetFrom) = 0;

	virtual unsigned long getSize() = 0;

	virtual void read( char* bytesToRead, unsigned long sizeOfBytes ) = 0;

	virtual void write( char* bytesToWrite, unsigned long sizeOfBytes ) = 0;

	virtual char* getBuffer() = 0;
};


};

#endif
