/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */


#ifndef PERSISTABLE_H
#define PERSISTABLE_H

#include "Stream.h"
#include <iostream>
	
namespace VCF{

/**
*Persistable is a simple interface that objects that support persistence can 
*implement. Persistable supports methods  saveToStream() and loadFromStream() as well as 
*operators >> and << 
*/
/** @interface */
class FRAMEWORK_API Persistable {
public:    

	virtual ~Persistable(){};

	/**
	*Write the object to the specified output stream
	*/
    virtual void saveToStream( OutputStream * stream ) = 0;
	
	/**
	**Read the object from the specified input stream
	*/
    virtual void loadFromStream( InputStream * stream ) = 0;

	
};

};
#endif //PERSISTABLE_H