/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

// TextOutputStream.h

#ifndef _TEXTOUTPUTSTREAM_H__
#define _TEXTOUTPUTSTREAM_H__


#include "Stream.h"
#include <vector>

namespace VCF
{

class FRAMEWORK_API TextOutputStream : public OutputStream  
{
public:	

	TextOutputStream( OutputStream* outStream );

	TextOutputStream();

	virtual ~TextOutputStream();

	virtual void seek(const unsigned long& offset, const SeekType& offsetFrom);

	virtual unsigned long getSize();

	virtual char* getBuffer();

	virtual void write( char* bytesToRead, unsigned long sizeOfBytes );
	
	/**
	*all numbers are written out as the number converted to text, followed by a 
	*space character ( ' ' ), so the value 2 becomes "2 "
	*/
	TextOutputStream& operator<<( const short& val );

	TextOutputStream& operator<<( const long& val );

	TextOutputStream& operator<<( const int& val );

	TextOutputStream& operator<<( const bool& val );

	TextOutputStream& operator<<( const char& val );

	TextOutputStream& operator<<( const float& val );

	TextOutputStream& operator<<( const double& val );

	virtual void write( const short& val );
	
	virtual void write( const long& val );

	virtual void write( const int& val );

	virtual void write( const bool& val );	

	virtual void write( const float& val );

	virtual void write( const double& val );

	virtual void write( const String& val );

	void init();

	void writeLine( const String& line );

	String getTextBuffer();

	virtual String toString();
private:
	String m_textBuffer;
	unsigned long m_size;	
	OutputStream* m_outStream;
};


};

#endif 
