// Socket.h

#ifndef _SOCKET_H__
#define _SOCKET_H__


#include "Object.h"
#include "VCF.h"


namespace VCFNet
{

//common socket errors
#define VCFNET_STARTUP_FAILED		-1
#define VCFNET_CANT_OPEN_SOCKET		-2
#define VCFNET_HOSTNAME_ERROR		-3
#define VCFNET_CONNECT_ERROR		-4
#define VCFNET_CONNECT_SUCCESS		-5
#define VCFNET_BIND_FAILED			-6
#define VCFNET_SERVER_STARTED		-7
#define VCFNET_NOHOST				""
#define VCFNET_NOPORT				-1

#define VCFNET_MAX_SOCKET_SIZE		512

class SocketPeer;

class NETKIT_API Socket : public VCF::Object  
{
public:

	enum SocketState{
		SOCKET_CLOSED_ERROR=0,
		SOCKET_READ_ERROR,
		SOCKET_WRITE_ERROR,
		SOCKET_OPEN_ERROR,
		SOCKET_NAME_ERROR,
		SOCKET_CREATE_ERROR,
		SOCKET_CONNECT_ERROR,
		SOCKET_WRITING,
		SOCKET_READING,
		SOCKET_CONNECTED,
	};

	Socket();

	Socket( const int& port );

	Socket( const VCF::String& host, const int& port );

	virtual ~Socket();	

	int getPort();

	void setPort( const int& port );

	VCF::String getHost();

	void setHost( const VCF::String& host );

	int send( const char* bytes, const VCF::uint32& size );
	

protected:
	SocketPeer* m_socketPeer;
};	

};

#endif 
