//SocketImplementer.h

#ifndef _SOCKET_IMPLEMENTER_H__
#define _SOCKET_IMPLEMENTER_H__

#include "VCF.h"

namespace VCFNet
{

class Socket;

class FRAMEWORK_API SocketImplementer {
public :
	virtual ~SocketImplementer(){};

	virtual int getLocalPort() = 0;
    
	virtual void setLocalPort( const int& localPort ) = 0;

	virtual VCF::String getLocalHost() = 0;

	virtual void setLocalHost( const VCF::String& localHost ) = 0;

	virtual int getPort() = 0;

	virtual void setPort( const int& port ) = 0;

	virtual VCF::String getHost() = 0;

	virtual void setHost( const VCF::String& host ) = 0;

	virtual Socket* getSocket() = 0;
	
	virtual void setSocket( Socket* socket ) = 0;

	virtual int send( const char* bytes, const VCF::uint32& size ) = 0;

	virtual int receive( char* data, VCF::uint32 &size ) = 0;
};

};



#endif