/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

// Resource.h

#ifndef _RESOURCE_H__
#define _RESOURCE_H__

#include "Object.h"
#include "VCF.h"


namespace VCF
{

class APPKIT_API Resource : public Object  
{
public:
	/**
	*the data passed in is copied - it is assumed that someone else owns
	*it - so it is not safe to destroy.
	*/
	Resource( void* data, const uint32& size, const String& name = "" );

	virtual ~Resource();
	
	void* getData();

	void setData( void* data );

	String getName();

	void setName( const String& name );

	uint32 getDataSize();
private:
	String m_name;
	void* m_data;
	uint32 m_size;
};

};

#endif
