/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

// StringUtils.h

#ifndef _STRINGUTILS_H__
#define _STRINGUTILS_H__

#include "VCF.h"
#include "VCFString.h"
#include <sstream>

#define MAX_TRACE_STRING		5000

class FRAMEWORK_API StringUtils  
{
public:
	StringUtils();
	virtual ~StringUtils();
	
	static VCF::String getFileDir( const VCF::String& fileName );

	static VCF::String getFileName( const VCF::String& fileName );

	static VCF::String getFileExt( const VCF::String& fileName );

	static void trace( const VCF::String& text );

	static void traceWithArgs( const VCF::String& text,... );

	static VCF::String lowerCase( const VCF::String& text );	

	static VCF::String upperCase( const VCF::String& text );	

	static VCF::String toString( const int& value );

	static VCF::String toString( const long& value );

	static VCF::String toString( const float& value );

	static VCF::String toString( const double& value );

	static VCF::String toString( const VCF::ulong32& value );

	static VCF::String toString( const VCF::uint32& value );

	static VCF::String toString( const char& value );

	static VCF::String toString( const bool& value );

	static VCF::String newUUID();
};



#endif 

	
