/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */


#include "Clipboard.h"
#include "ClipboardPeer.h"
#include "ClipboardDataObject.h"
#include "UIToolkit.h"

using namespace VCF;


Clipboard::Clipboard()
{
	m_clipboardPeer = NULL;

	UIToolkit* toolkit = UIToolkit::getDefaultUIToolkit();
	m_clipboardPeer = toolkit->createClipboardPeer();

}

Clipboard::~Clipboard()
{

}

bool Clipboard::hasDataType(const unsigned long & dataType)
{
	return false;
}

void Clipboard::setContents( ClipboardDataObject* dataObject )
{
	if ( NULL != m_clipboardPeer ){
		
		m_dataObject = dataObject;
		ClipboardEvent event( this );	
		event.setType( CLIPBOARD_EVENT_ITEM_ADDED );
		
		m_clipboardPeer->copy( dataObject );

		this->notify_onClipboardContentsChanged( &event );
		this->notify_onClipboardItemCopied( &event );
	}
}

ClipboardDataObject* Clipboard::getContents()
{
	return m_dataObject;
}

void Clipboard::deleteDataObject( ClipboardDataObject* dataObject )
{
	ClipboardEvent event( this );
	event.setType( CLIPBOARD_EVENT_ITEM_DELETED );
	this->notify_onClipboardContentsChanged( &event );
}

