/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#include "DragSource.h"
#include "UIToolkit.h"
#include "DragDropPeer.h"
#include "Clipboard.h"

using namespace VCF;


DragSource::DragSource()
{
	this->m_dragDropPeer =  UIToolkit::getDefaultUIToolkit()->createDragDropPeer();
	m_dragDropPeer->setDragSource( this );
	m_actionType = DRAG_ACTION_COPY;
}

DragSource::~DragSource()
{
	delete m_dragDropPeer;
}



void DragSource::startDragDrop( ClipboardDataObject* data )
{	
	if ( NULL != this->m_dragDropPeer ){
		DragEvent event( this, data );
	
		m_clipboardDataObject = data;
		this->copyDataToClipboard();

		this->notify_onDragSourceBegin( &event );

		m_dragDropPeer->startDragDrop( m_clipboardDataObject );
		//notify the end of the darg drop op
		this->notify_onDragSourceEnd( &event );
			
	}
}

void DragSource::copyDataToClipboard()
{
	//copy the data to the clipboard
	Clipboard* systemClipboard = UIToolkit::getDefaultUIToolkit()->getSystemClipboard();
	if ( NULL != systemClipboard ){
		systemClipboard->setContents( m_clipboardDataObject );			
	}
}

void DragSource::setActionType( const DragActionType& actionType )
{
	m_actionType = actionType;
}

DragActionType DragSource::getActionType()
{
	return this->m_actionType;
}
