/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */


#include "DropTarget.h"
#include "UIToolkit.h"
#include "DropTargetPeer.h"


using namespace VCF;

DropTarget::DropTarget( Control* component )
{
	this->m_dropTargetPeer = UIToolkit::getDefaultUIToolkit()->createDropTargetPeer();
	if ( NULL != m_dropTargetPeer ){
		m_dropTargetPeer->setDropTarget( this );
		m_dropTargetPeer->registerTarget( component );
	}
}


DropTarget::~DropTarget()
{
	if ( NULL != m_dropTargetPeer ){
		delete m_dropTargetPeer;
		m_dropTargetPeer = NULL;
	}
}

void DropTarget::getSupportedActions()
{
	if ( NULL != m_dropTargetPeer ){
		delete m_dropTargetPeer;
	}
	m_dropTargetPeer = NULL;
}

void DropTarget::processEvents( Event* event )
{
	if ( NULL != event ){
		unsigned long eventType = event->getType();
		switch ( eventType ){
			case DROPTARGET_EVENT_ENTERED:{
				this->notify_onDropTargetEntered( (DragEvent*)event ); 
			}
			break;

			case DROPTARGET_EVENT_DROPPED:{
				this->notify_onDropTargetDropped( (DropEvent*)event ); 
			}
			break;			
		}
	}
}

DropTargetPeer* DropTarget::getDropTargetPeer()
{
	return this->m_dropTargetPeer;
}