/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */


#include "Event.h"


using namespace VCF;

Event::Event( Object * source)
{
	this->m_source = source;
	this->init();
}

Event::Event( Object* source, const unsigned long& eventType )
{
	this->m_source = source;
	this->m_eventType = eventType;
}

void Event::init()
{
	m_consumed = false;
	time( &this->m_time );
}

Object* Event::getSource()
{
	return this->m_source;
}

unsigned long Event::getType()
{
	return this->m_eventType;
}

void Event::setType( const unsigned long& type )
{
	this->m_eventType = type;
}

time_t Event::getTime()
{
	return this->m_time;
}

void Event::setUserData( void* userData )
{
	this->m_userData = userData;
}

void* Event::getUserData()
{
	return this->m_userData;
}