/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

// ImageEvent.cpp


#include "ImageEvent.h"

using namespace VCF;


ImageEvent::ImageEvent( Object* source ):
	Event( source )
{
	
}

ImageEvent::~ImageEvent()
{

}

void ImageEvent::init()
{
	this->m_newWidth = 0;
	this->m_newHeight = 0;
}

unsigned long ImageEvent::getNewWidth()
{
	return this->m_newWidth;
}

void ImageEvent::setNewWidth( const unsigned long& newWidth )
{
	this->m_newWidth = newWidth;
}

unsigned long ImageEvent::getNewHeight()
{
	return this->m_newHeight;
}

void ImageEvent::setNewHeight( const unsigned long& newHeight )
{
	this->m_newHeight = newHeight;
}