/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

// ItemEvent.cpp


#include "ItemEvent.h"

using namespace VCF;

ItemEvent::ItemEvent( Object* source ):
	Event( source )
{
	m_paintContext = NULL;
}

ItemEvent::ItemEvent( Object* source, GraphicsContext* context ):
	Event( source, ITEM_EVENT_PAINT )	
{
	this->m_paintContext = context;
}

ItemEvent::ItemEvent( Object* source, const unsigned long& eventType ):
	Event( source, eventType )
{
	m_paintContext = NULL;
}

ItemEvent::~ItemEvent()
{

}

GraphicsContext* ItemEvent::getContext()
{
	return this->m_paintContext;
}

Point* ItemEvent::getPoint()
{
	return  &this->m_point;
}

void ItemEvent::setPoint( Point* point )
{
	m_point.m_x = point->m_x;
	m_point.m_y = point->m_y;
}