/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#include "KeyboardEvent.h"

using namespace VCF;

KeyboardEvent::KeyboardEvent( Object* source ):
	Event( source )
{
	this->init();
}

KeyboardEvent::KeyboardEvent( Object* source, const unsigned long& eventType, 
							 const unsigned long& repeatCount, const unsigned long& keyMask,
							 const VCFChar& keyValue,
							 const ulong32& virtKeyValue ):
	Event( source, eventType )
{
	this->init();
	this->m_keyMask = keyMask;
	this->m_repeatCount = repeatCount;
	this->m_keyValue = keyValue;
	this->m_virtualKeyCode = virtKeyValue;
}

void KeyboardEvent::init()
{
	this->m_keyMask = 0;
	this->m_keyValue = 0;
	this->m_repeatCount = 0;
}

unsigned long KeyboardEvent::getKeyMask()
{
	return this->m_keyMask;
}

VCF::VCFChar KeyboardEvent::getKeyValue()
{		
	return this->m_keyValue;
}

bool KeyboardEvent::hasShiftKey()
{
	return ( KEY_SHIFT & this->m_keyMask ) != 0;
}

bool KeyboardEvent::hasAltKey()
{
	return ( KEY_ALT & this->m_keyMask ) != 0;
}

bool KeyboardEvent::hasControlKey()
{
	return ( KEY_CTRL & this->m_keyMask ) != 0;
}

ulong32 KeyboardEvent::getVirtualCode()
{
	return this->m_virtualKeyCode;
}