/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */


#include "MouseEvent.h"

using namespace VCF;


MouseEvent::MouseEvent( Object* source ):
	Event( source )
{
	this->init();
}

MouseEvent::MouseEvent( Object* source, const unsigned long& eventType ):
	Event( source )
{
	this->init();
	this->setType( eventType );
}
	
MouseEvent::MouseEvent( Object* source, const unsigned long& eventType, const unsigned long& buttonMask, 
					    const unsigned long& keyMask, Point* point ):
	Event( source )
{
	this->init();
	this->setType( eventType );
	this->m_buttonMask = buttonMask;
	this->m_keyMask = keyMask;
	this->m_point = *point;	
}

void MouseEvent::init()
{
	m_point.m_x = 0.0;
	m_point.m_y = 0.0;

	this->m_keyMask = 0;
	this->m_buttonMask = 0;
}

unsigned long MouseEvent::getButtonMask()
{
	return m_buttonMask;
}

unsigned long MouseEvent::getKeyMask()
{
	return m_keyMask;
}

Point* MouseEvent::getPoint()
{
	return &this->m_point;
}

void MouseEvent::setPoint( Point* point )
{
	this->m_point.m_x = point->m_x;
	this->m_point.m_y = point->m_y;
}

bool MouseEvent::hasLeftButton()
{
	return ( MOUSE_LEFT_BUTTON & this->m_buttonMask ) != 0;
}

bool MouseEvent::hasMiddleButton()
{
	return ( MOUSE_MIDDLE_BUTTON & this->m_buttonMask ) != 0;
}

bool MouseEvent::hasRightButton()
{
	return ( MOUSE_RIGHT_BUTTON & this->m_buttonMask ) != 0;
}

bool MouseEvent::hasShiftKey()
{
	return ( KEY_SHIFT & this->m_keyMask ) != 0;
}

bool MouseEvent::hasAltKey()
{
	return ( KEY_ALT & this->m_keyMask ) != 0;
}

bool MouseEvent::hasControlKey()
{
	return ( KEY_CTRL & this->m_keyMask ) != 0;
}