/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

// PropertyChangeEvent.cpp

#include "PropertyChangeEvent.h"
#include "Property.h"

using namespace VCF;

PropertyChangeEvent::PropertyChangeEvent( Object * source, VariantData* changeValue, VariantData* originalValue ):
	Event( source )
{
	this->m_changeValue = changeValue;
	this->m_originalValue = originalValue;
}

PropertyChangeEvent::~PropertyChangeEvent()
{

}

VariantData* PropertyChangeEvent::getChangeValue()
{
	return this->m_changeValue;
}

VariantData* PropertyChangeEvent::getOriginalValue()
{
	return this->m_originalValue;
}