/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */


#include "AbstractImage.h"
#include "GraphicsContext.h"
#include "ImageBits.h"

using namespace VCF;

AbstractImage::AbstractImage()
{
	m_imageBits = new ImageBits(0,0);
	m_bitDepth = BD_32BP;
}

AbstractImage::~AbstractImage()
{
	delete m_context;
	delete m_imageBits;
}

void AbstractImage::setWidth(const unsigned long & width)
{
	this->m_width = width;
	this->m_imageBits->setWidth( width );
	ImageEvent event(this);
	event.setType( IMAGE_EVENT_WIDTH_CHANGED );
	event.setNewWidth( width );
	notify_onSizeChanged( &event );
}

unsigned long AbstractImage::getWidth()
{
	return this->m_width;
}

void AbstractImage::setHeight(const unsigned long & height){
	this->m_height = height;
	this->m_imageBits->setHeight( height );

	ImageEvent event(this);
	event.setType( IMAGE_EVENT_HEIGHT_CHANGED );
	event.setNewHeight( height );
	notify_onSizeChanged( &event );
}

unsigned long AbstractImage::getHeight(){
	return this->m_height;
}

GraphicsContext* AbstractImage::getImageContext()
{
	return m_context;
}

ImageBits* AbstractImage::getImageBits()
{
	return m_imageBits;
}

ImageBitDepth AbstractImage::getBitDepth()
{
	return m_bitDepth;
}