/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

//FontState.cpp

#include "FontState.h"

using namespace VCF;
 

FontState::FontState()
{
	this->init();
}

FontState::~FontState()
{

}

void FontState::init()
{
	this->m_angle = 0.0;
	this->m_bold = false;
	this->m_height = 12.0;
	this->m_italicized = false;
	this->m_name = "Arial";
	this->m_strikeOut = false;
	this->m_underlined = false;
}

String FontState::toString()
{
	String result = Object::toString();
	char info[256];
	sprintf( info, "angle : %f \nbold : %d \nheight : %f \nitalic : %d \nName : %s \nstrikeOut : %d \nunderlined : %d\n",
		     this->m_angle,this->m_bold,this->m_height,
			 this->m_italicized, this->m_name.c_str(), this->m_strikeOut, this->m_underlined );		     
	result += "\n";
	result += info;
	return result;
}
