/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

// BasicOutputStream.cpp


#include "BasicOutputStream.h"
#include "Persistable.h"

using namespace VCF;


BasicOutputStream::BasicOutputStream()
{
	this->init();
}

BasicOutputStream::~BasicOutputStream()
{
	
}

BasicOutputStream::BasicOutputStream( OutputStream* outStream )
{
	this->init();
	this->m_outputStream = outStream;
}	

void BasicOutputStream::init()
{
	m_size = 0;
	this->m_outputStream = NULL;
}

void BasicOutputStream::seek(const unsigned long& offset, const SeekType& offsetFrom)
{
	
}

unsigned long BasicOutputStream::getSize()
{
	return m_size;
}

char* BasicOutputStream::getBuffer()
{
	if ( NULL != m_outputStream ){
		return m_outputStream->getBuffer();
	}
	else {
		return m_outStream.getBuffer();
	}
	return NULL;
}

void BasicOutputStream::write( char* bytesToRead, unsigned long sizeOfBytes )
{	
	if ( NULL != m_outputStream ){
		m_outputStream->write( bytesToRead, sizeOfBytes );
	}
	else {
		this->m_outStream.write( (char*)bytesToRead, sizeOfBytes );
	}
	m_size += sizeOfBytes;
}
