/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

#include "VCF.h"

#include "File.h"

#ifdef WIN32
	#include "Win32FilePeer.h"
#endif

using namespace VCF;

File::File( const String& fileName )
{
	m_filePeer = NULL;

#ifdef WIN32 
	m_filePeer = new Win32FilePeer( fileName );
#endif

}

File::~File()
{
	if ( NULL != m_filePeer ){
		delete m_filePeer;
	}
	m_filePeer = NULL;
}

void File::remove()
{
	m_filePeer->remove();
}

void File::create()
{
	m_filePeer->create();
}

uint32 File::getSize()
{
	return m_filePeer->getSize();
}

String File::getName()
{
	return m_filePeer->getName();
}

void File::setName( const String& fileName )
{
	m_filePeer->setName( fileName );
}


