/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

//MemoryStream.cpp

#include "MemoryStream.h"
#include "Persistable.h"

using namespace VCF;



MemoryStream::MemoryStream()
{
	
}

MemoryStream::MemoryStream( OutputStream* outStream )
{
	if ( NULL != outStream ){
		this->init();
		this->m_outputStream = outStream;
	}
	//else throw exception ?
}

MemoryStream::MemoryStream( InputStream* inStream )
{
	if ( NULL != inStream ){
		this->init();
		this->m_inputStream = inStream;
	}
}

MemoryStream::~MemoryStream()
{
	
}

void MemoryStream::init()
{
	this->m_inputStream = NULL;
	this->m_outputStream = NULL;
	this->m_size = 0;
}

void MemoryStream::seek(const unsigned long& offset, const SeekType& offsetFrom)
{
	
}

unsigned long MemoryStream::getSize()
{		
	return m_size;
}

void MemoryStream::write( Persistable* persistableObject )
{
	if ( NULL != this->m_outputStream ){
		m_outputStream->write( persistableObject );
	}
	else {
		persistableObject->saveToStream( this );		
	}
}

void MemoryStream::write( char* bytesToWrite, unsigned long sizeOfBytes )
{	
	if ( NULL != this->m_outputStream ){
		m_outputStream->write( bytesToWrite, sizeOfBytes );
	}
	else {
		this->m_stream.write( bytesToWrite, sizeOfBytes );
	}
	m_size += sizeOfBytes;
}

void MemoryStream::read( char* bytesToRead, unsigned long sizeOfBytes )
{
	if ( NULL != this->m_inputStream ){
		m_inputStream->read( bytesToRead, sizeOfBytes );
	}
	else {
		this->m_stream.get( bytesToRead, sizeOfBytes );
	}
}
