/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

// Win32Component.cpp


#include "Win32Component.h"

#include "Win32ToolKit.h"

using namespace VCF;

using namespace VCFWin32;


Win32Component::Win32Component( Control* component ):
	AbstractWin32Component( component )
{
	
	if ( true != this->isRegistered() ){
		registerWin32Class( this->getClassName(), m_wndProc  );
	}

	Win32ToolKit* toolkit = (Win32ToolKit*)UIToolkit::getDefaultUIToolkit();
	HWND parent = toolkit->getDummyParent();	

	String className = this->getClassName();

	this->m_hwnd = ::CreateWindowEx( this->m_exStyleMask, className.c_str(), 
									 this->m_windowCaption.c_str(),	this->m_styleMask, 
		                             this->m_bounds.m_left, this->m_bounds.m_top, 
									 this->m_bounds.getWidth(), this->m_bounds.getHeight(), parent, 
									 NULL, ::GetModuleHandle(NULL), NULL );

	if ( NULL != this->m_hwnd ){
		Win32Object::registerWin32Object( this );	
	}
	else {
		//throw exception
	}

	this->setCreated( true );
}

Win32Component::~Win32Component()
{

}

