/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

#include "Win32ControlContext.h"
#include "ControlGraphicsContext.h"
#include "ControlPeer.h"
#include "Control.h"

using namespace VCF;

Win32ControlContext::Win32ControlContext( ControlPeer* controlPeer )
{
	Win32Context::init();
	if ( NULL == controlPeer ){
		//throw exception 
	}

	//this->m_dc = GetDC( (HWND)controlPeer->getHandleID() );	
}

Win32ControlContext::~Win32ControlContext()
{

}

void Win32ControlContext::setContext( GraphicsContext* context )
{
	Win32Context::setContext ( context );
	this->m_owningControlCtx  = dynamic_cast<ControlGraphicsContext*>( context );
}

Control* Win32ControlContext::getOwningControl()
{
	Control* result = NULL;

	if ( NULL != this->m_owningControlCtx ){
		result = m_owningControlCtx->getOwningControl();
	}
	return result;
}

void Win32ControlContext::releaseHandle()
{
	
	if ( (NULL != this->m_owningControlCtx->getOwningControl()) && (NULL != m_dc) ){
		ControlPeer* peer = this->m_owningControlCtx->getOwningControl()->getPeer();
		::ReleaseDC( (HWND)peer->getHandleID(), m_dc );
	}
	
}

void Win32ControlContext::checkHandle()
{	
	if ( NULL != this->m_owningControlCtx->getOwningControl() ){
		
		ControlPeer* peer = this->m_owningControlCtx->getOwningControl()->getPeer();
		m_dc = ::GetDC( (HWND)peer->getHandleID() );

		if ( NULL == this->m_dc ){
			//throw exception !!!!!!
		}
	}	
}

/*

void Win32ControlContext::checkHandle()
{
	if ( NULL == m_owningControlCtx ){
		//throw exception !!
	}

	if ( NULL != this->m_owningControlCtx->getOwningControl() ){
		if ( NULL == this->m_dc ){
			if ( MAX_WIN32_CTXT_CACHE_COUNT < Win32Context::win32ContextCacheCount ){
				Win32Context::removeContext( this );
			}
			Win32Context::addContext( this );
			ControlPeer* peer = this->m_owningControlCtx->getOwningControl()->getPeer();
			m_dc = ::GetDC( (HWND)peer->getHandleID() );

			if ( NULL == this->m_dc ){
				//throw exception !!!!!!
			}
		}		

	}
}

void Win32ControlContext::removeContext( Win32Context* context )
{
	if ( NULL == m_owningControlCtx ){
		//throw exception !!
	}
	Win32ControlContext* controlCtx = dynamic_cast<Win32ControlContext*>(context);
	if ( NULL != controlCtx ){
		Control* control = controlCtx->getOwningControl();
		if ( (NULL != control) && (false == win32ContextList.empty()) ){
			Win32Context* firstCtx = Win32Context::win32ContextList[0];
			if ( NULL != firstCtx ){			
				firstCtx->setContextID( 0 );
			}
			Win32Context::win32ContextList.pop_front();
			Win32Context::win32ContextCacheCount --;
			ControlPeer* peer  = control->getPeer();
			StringUtils::trace( "removeing DC...\n" );
			if ( NULL != peer ){
				StringUtils::trace( "/////////peer != NULL !!!!!////////////\n" );
				HDC dc = context->getDC();
				HWND wnd = (HWND)peer->getHandleID();		
				if ( ::ReleaseDC( wnd, dc ) ){
					StringUtils::trace( "Released dc " + StringUtils::toString( (int)dc ) + 
						"for wnd " + StringUtils::toString( (int)wnd ) + "\n" );
				}
			}
			else {
				StringUtils::trace( ">>>>>>>>>>peer == NULL !!!!!<<<<<<<<<<<<<\n" );
			}
			StringUtils::trace( "popping old \n\t" + context->toString() + 
				"\nwin32ContextCacheCount = " + StringUtils::toString( Win32Context::win32ContextCacheCount ) + "\n" );
		}
	}

}

void Win32ControlContext::addContext( Win32Context* context )
{
	Win32Context::win32ContextList.push_back( context );
	Win32Context::win32ContextCacheCount ++;
	StringUtils::trace( "pushing new \n\t" + context->toString() + 
		                "\nwin32ContextCacheCount = " + StringUtils::toString( Win32Context::win32ContextCacheCount ) + "\n" );
	
}

  */