/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 


#include "Win32FolderBrowseDialog.h"
#include "Win32Peer.h"


using namespace VCF;

Win32FolderBrowseDialog::Win32FolderBrowseDialog()
{

}

Win32FolderBrowseDialog::~Win32FolderBrowseDialog()
{

}

void Win32FolderBrowseDialog::setTitle( const String& title )
{
	m_title = title;
}

bool Win32FolderBrowseDialog::execute()
{
	bool result = false;
	BROWSEINFO info = {0};
	TCHAR displayName[MAX_PATH];
	memset(displayName,0,MAX_PATH);

	int sz = m_title.size() + 1;
	TCHAR* title = new TCHAR[sz];
	memset( title, 0, sz );
	m_title.copy( title, m_title.size() );

	info.hwndOwner = ::GetActiveWindow();
	info.pidlRoot = NULL;
	info.pszDisplayName = displayName;
	info.lpszTitle = title;
	info.ulFlags = 0; 

	LPITEMIDLIST itemIDList = SHBrowseForFolder( &info );
	if ( NULL != itemIDList ){
		TCHAR path[MAX_PATH];
		memset(path,0,MAX_PATH);
		if ( TRUE == SHGetPathFromIDList( itemIDList, path ) ){
			m_directory = path;
			result = true;
		}
	}

	return result;

}

void Win32FolderBrowseDialog::setDirectory( const String & directory )
{
	m_directory = m_directory;
}

String Win32FolderBrowseDialog::getDirectory()
{
	return m_directory;
}