/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

// Win32MenuBar.cpp


#include "Win32MenuBar.h"
#include "MenuItemPeer.h"
#include "ControlPeer.h"
#include "Frame.h"

using namespace VCF;


Win32MenuBar::Win32MenuBar(  MenuBar* menuBar  )
{
	m_frame = NULL;
	this->m_menuRoot = menuBar->getRootMenuItem();
}

Win32MenuBar::~Win32MenuBar()
{

}

void Win32MenuBar::setFrame( Frame* frame )
{
	m_frame = frame;
	if ( (NULL != m_frame) && (NULL != m_menuRoot) ){		
		ControlPeer* Peer = m_frame->getPeer();
		HWND wnd = (HWND)Peer->getHandleID();
		
		MenuItemPeer* itemImpl = m_menuRoot->getPeer();
		
		HMENU menu = (HMENU) itemImpl->getMenuID();
		SetMenu( wnd, menu );
	}
}

void Win32MenuBar::update()
{
	if ( (NULL != m_frame) && (NULL != m_menuRoot) ){		
		ControlPeer* Peer = m_frame->getPeer();
		HWND wnd = (HWND)Peer->getHandleID();

		DrawMenuBar( wnd );
	}
}

void Win32MenuBar::setMenuItems( MenuItem* item )
{
	m_menuRoot = item;
}