/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

#include "Win32Peer.h"
#include "Control.h"
#include "Point.h"
#include "PopupMenu.h"
#include "Win32PopupMenu.h"
#include "MenuItemPeer.h"
#include "ControlPeer.h"

using namespace VCF;

Win32PopupMenu::Win32PopupMenu( PopupMenu* popupMenu )
{
	m_control = NULL;
	m_popupMenu = popupMenu;	
}

Win32PopupMenu::~Win32PopupMenu()
{

}

void Win32PopupMenu::setControl( Control* control )
{
	m_control = control;
}

void Win32PopupMenu::popup( Point* pt )
{
	if ( (NULL != m_control) && (NULL != pt) ){
		MenuItemPeer* peer = m_popupMenu->getRootMenuItem()->getPeer();
		ControlPeer* controlPeer = m_control->getPeer();
		if ( (NULL == peer) || (NULL == controlPeer) ){
			//throw exception
		}
		HMENU menuHandle = (HMENU)peer->getMenuID();
		UINT flags = TPM_LEFTALIGN | TPM_TOPALIGN | TPM_RIGHTBUTTON;
		HWND wnd = (HWND)controlPeer->getHandleID();
		POINT tmpPt = {0};
		tmpPt.x = pt->m_x;
		tmpPt.y = pt->m_y;
		ClientToScreen( wnd, &tmpPt );
		UINT retVal = ::TrackPopupMenu( menuHandle, flags, tmpPt.x, tmpPt.y, 0, wnd, NULL );
		if ( 0 != retVal ){
			
		}
	}
}
