/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

// Resource.cpp


#include "Resource.h"

using namespace VCF;

Resource::Resource( void* data, const uint32& size, const String& name )
{
	this->m_data = new char[size];
	memset( m_data, 0, size );
	memcpy( m_data, data, size );
	this->m_size = size;
	this->m_name = name;
}

Resource::~Resource()
{
	delete m_data;
}

void* Resource::getData()
{
	return m_data;
}

String Resource::getName()
{
	return m_name;
}

void Resource::setName( const String& name )
{
	m_name = name;
}

uint32 Resource::getDataSize()
{
	return m_size;
}