/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

//AbstractTreeModel.cpp

#include "AbstractTreeModel.h"

using namespace VCF;

AbstractTreeModel::AbstractTreeModel()
{
	this->init();
	
}

AbstractTreeModel::~AbstractTreeModel()
{
	
}

void AbstractTreeModel::init()
{
	this->m_rootNodeItem = NULL;	
}

void AbstractTreeModel::validate()
{

}

void AbstractTreeModel::empty()
{
	this->m_rootNodeItem->clearChildren();
}

TreeItem* AbstractTreeModel::getRoot()
{
	return m_rootNodeItem;
}

void AbstractTreeModel::setRoot( TreeItem* root )
{
	if ( m_rootNodeItem != NULL ){
		delete m_rootNodeItem;
		m_rootNodeItem = NULL;
	}
	this->m_rootNodeItem = root;
}

void AbstractTreeModel::insertNodeItem(TreeItem * node, TreeItem * nodeToInsertAfter)
{

}

void AbstractTreeModel::deleteNodeItem(TreeItem * nodeToDelete)
{

}

void AbstractTreeModel::addNodeItem( TreeItem * node, TreeItem * nodeParent )
{
	if ( NULL == nodeParent ){
		this->m_rootNodeItem = node;
		TreeModelEvent event(this, node );
		this->notify_onRootNodeChanged( &event );
	}
	else {
		TreeModelEvent event(this, node );
		this->notify_onNodeAdded( &event );
	}
	
}

void AbstractTreeModel::sort()
{

}

void AbstractTreeModel::onItemPaint( ItemEvent* event )
{

}

void AbstractTreeModel::onItemChanged( ItemEvent* event )
{
	if ( NULL != event ){
		switch ( event->getType() ){
			case ITEM_EVENT_TEXT_CHANGED:{
				
			}
			break;
		}
	}
}

void AbstractTreeModel::onItemSelected( ItemEvent* event )
{

}

void AbstractTreeModel::onItemAdded( ItemEvent* event )
{

}

	
void AbstractTreeModel::onItemDeleted( ItemEvent* event )
{

}