//ApplicationKit.cpp

/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 



#include "ApplicationKit.h"
#include "FoundationKit.h"
#include "GraphicsKit.h"
#include "UIToolkit.h"
#include "Item.h"
#include "ListItem.h"
#include "ListModel.h"
#include "MenuItem.h"
#include "Model.h"
#include "TabModel.h"
#include "TabPage.h"
#include "TextModel.h"
#include "TreeItem.h"
#include "TreeModel.h"
#include "Border.h"
#include "AbstractListModel.h"
#include "AbstractTextModel.h"
#include "AbstractTreeModel.h"
#include "Component.h"
#include "DefaultListItem.h"
#include "DefaultListModel.h"
#include "DefaultTextModel.h"
#include "DefaultTreeItem.h"
#include "DefaultTreeModel.h"
#include "Frame.h"
#include "Dialog.h"
#include "Label.h"
#include "ListViewControl.h"
#include "Panel.h"
#include "TextControl.h"
#include "TreeControl.h"
#include "Window.h"
#include "Basic3DBorder.h"
#include "Control.h"
#include "CustomControl.h"
#include "TabbedPages.h"
#include "CheckBoxControl.h"
#include "MenuBar.h"
#include "Menu.h"
#include "PopupMenu.h"
#include "ListBoxControl.h"
#include "CommandButton.h"
#include "OpenGLControl.h"
#include "StringUtils.h"

#include "MouseEvent.h"
#include "Stream.h"
#include "FileStream.h"
#include "Border.h"
#include "GraphicsContext.h"
#include "ComboBoxControl.h"
#include "TableModel.h"
#include "DefaultTableModel.h"
#include "ToolbarDock.h"

using namespace VCF;


void initApplicationKit()
{
	initFoundationKit();
	initGraphicsKit();

	REGISTER_CLASSINFO( Item );
	REGISTER_CLASSINFO( ListItem );
	REGISTER_CLASSINFO( Model );
	REGISTER_CLASSINFO( ListModel );
	REGISTER_CLASSINFO( MenuItem );	
	REGISTER_CLASSINFO(TabModel);
	REGISTER_CLASSINFO(TabPage);
	REGISTER_CLASSINFO( TextModel );
	REGISTER_CLASSINFO( TreeItem );
	REGISTER_CLASSINFO( TreeModel );
	REGISTER_CLASSINFO( Border );
	REGISTER_CLASSINFO( AbstractListModel );
	REGISTER_CLASSINFO( AbstractTextModel );
	REGISTER_CLASSINFO( AbstractTreeModel );
	REGISTER_CLASSINFO( Component );
	REGISTER_CLASSINFO( Control );
	REGISTER_CLASSINFO( CustomControl );
	REGISTER_CLASSINFO( TabbedPages );	
	REGISTER_CLASSINFO( DefaultListItem );
	REGISTER_CLASSINFO( DefaultListModel );
	REGISTER_CLASSINFO( DefaultTextModel );
	REGISTER_CLASSINFO( DefaultTreeItem );
	REGISTER_CLASSINFO( DefaultTreeModel );
	REGISTER_CLASSINFO( Frame );
	REGISTER_CLASSINFO( Dialog );
	REGISTER_CLASSINFO( Label );	
	REGISTER_CLASSINFO( ListViewControl );
	REGISTER_CLASSINFO( Panel );
	REGISTER_CLASSINFO( TextControl );
	REGISTER_CLASSINFO(TreeControl );
	REGISTER_CLASSINFO(Window );
	REGISTER_CLASSINFO( CheckBoxControl );	
	REGISTER_CLASSINFO( Menu );
	REGISTER_CLASSINFO( MenuBar );
	REGISTER_CLASSINFO( PopupMenu );
	REGISTER_CLASSINFO( ListBoxControl );
	REGISTER_CLASSINFO( Basic3DBorder );
	REGISTER_CLASSINFO( CommandButton );	
	REGISTER_CLASSINFO( OpenGLControl );
	REGISTER_CLASSINFO( ComboBoxControl );
	REGISTER_CLASSINFO( ToolbarDock );

	UIToolkit::initToolKit();

	Component::registerComponent( "VCF::OpenGLControl", STANDARD_CATEGORY );
	Component::registerComponent( "VCF::ToolbarDock", STANDARD_CATEGORY );	
	/**
	*Register known classes here
	*/
	
}
