/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#include "CommonFileDialog.h"
#include "CommonDialogPeer.h"


using namespace VCF;


CommonFileDialog::CommonFileDialog()
{
	m_Peer = NULL;
}

CommonFileDialog::~CommonFileDialog()
{

}


void CommonFileDialog::addFilter(const String & description, const String & extension)
{
	m_Peer->addFilter( description, extension );
}

void CommonFileDialog::setDirectory(const String & directory)
{
	m_Peer->setDirectory( directory );
}
        
void CommonFileDialog::setFileName(const String & filename)
{
	m_Peer->setFileName( filename );
}

String CommonFileDialog::getFileName()
{	
	String result;
	return m_Peer->getFileName();
}

String CommonFileDialog::getDirectory()
{
	
	return m_Peer->getDirectory();
}

String CommonFileDialog::getFileExtension()
{
	return m_Peer->getFileExtension();
}

void CommonFileDialog::setAllowsMultiSelect( const bool& allowsMultiSelect )
{
	this->m_Peer->setAllowsMultiSelect( allowsMultiSelect );
}

void CommonFileDialog::setTitle( const String& title )
{
	this->m_Peer->setTitle( title );
}