/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#include "CommonFileSave.h"
#include "CommonDialogPeer.h"
#include "UIToolkit.h"
#include "Control.h"

using namespace VCF;

CommonFileSave::CommonFileSave( Control* owner, const String& startDir )
{
	UIToolkit* toolkit = UIToolkit::getDefaultUIToolkit();
	if ( NULL == toolkit ){
		//throw exception !!
	}
	m_Peer = toolkit->createCommonFileSaveDialogPeer( owner );
	if ( NULL == m_Peer ){
		//throw exception
	}

	if ( startDir.size() > 0 ){
		this->setDirectory( startDir );
	}
}

CommonFileSave::~CommonFileSave()
{
	delete m_Peer;
}


bool CommonFileSave::execute()
{
	return m_Peer->execute();
}