/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

// DefaultListItem.cpp


#include "DefaultListItem.h"

using namespace VCF;


DefaultListItem::DefaultListItem()
{
	init();
}

DefaultListItem::DefaultListItem( Model* model )
{
	init();
	m_model = model;
}

DefaultListItem::DefaultListItem( Model* model, const String& caption )
{
	init();
	m_model = model;
	m_caption = caption;
}

DefaultListItem::~DefaultListItem()
{

}

void DefaultListItem::init()
{
	m_model = NULL;
	
}

bool DefaultListItem::containsPoint( Point * pt )
{
	return false;
}

Image* DefaultListItem::getImage()
{
	return m_image;
}

unsigned long DefaultListItem::getIndex()
{
	return m_index;
}

void DefaultListItem::setIndex( const unsigned long& index )
{
	m_index = index;
}

void* DefaultListItem::getData()
{
	return m_data;
}

void DefaultListItem::setData( void* data )
{
	m_data = data;
}

String DefaultListItem::getCaption()
{
	return m_caption;
}

void DefaultListItem::setCaption( const String& caption )
{
	m_caption = caption;
	ItemEvent event( this, ITEM_EVENT_TEXT_CHANGED );
	notify_onItemChanged( &event );
}

Model* DefaultListItem::getModel()
{
	return this->m_model;
}

void DefaultListItem::setModel( Model* model )
{
	m_model = model;
}

void DefaultListItem::paint( GraphicsContext* context, Rect* paintRect )
{
	
}
	
bool DefaultListItem::isSelected()
{
	return m_selected;
}

void DefaultListItem::setSelected( const bool& selected )
{
	m_selected = selected;
}