/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

// DefaultTreeModel.cpp


#include "DefaultTreeModel.h"
#include "DefaultTreeItem.h"


using namespace VCF;

DefaultTreeModel::DefaultTreeModel()
{
	this->setRoot( new DefaultTreeItem( "", this ) );	
}

DefaultTreeModel::DefaultTreeModel( TreeItem* root )
{	

	root->setModel( this );
	this->setRoot( root );
}

DefaultTreeModel::~DefaultTreeModel()
{
	TreeItem* root = this->getRoot();
	if ( NULL != root ){
		delete root;
	}
}

void DefaultTreeModel::init()
{
	TreeItem* root = this->getRoot();
	if ( NULL != root ){
		root->addItemListener( this );
	}
}

void DefaultTreeModel::onItemPaint( ItemEvent* event )
{

}

void DefaultTreeModel::onItemChanged( ItemEvent* event )
{

}

void DefaultTreeModel::onItemSelected( ItemEvent* event )
{

}

void DefaultTreeModel::onItemAdded( ItemEvent* event )
{

}
	
void DefaultTreeModel::onItemDeleted( ItemEvent* event )
{

}