/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */


#include "Label.h"
#include "Rect.h"
#include "GraphicsContext.h"


using namespace VCF;

Label::Label():
	CustomControl( false )
{
	
	this->m_caption = this->getClassName();	
	this->setTransparent( true );
}

void Label::paint( GraphicsContext * context )
{
	CustomControl::paint( context );
	context->setCurrentFont( this->getFont() );
	double y = this->getBounds()->getHeight() / 4;
	double x = this->getClientBounds( false )->m_left;	
	context->setColor( &Color(0.0f,0.0f,0.0f) );
	context->textAt( x, y, this->m_caption );
}

void Label::setCaption( const String& caption )
{
	m_caption = caption;
}

String Label::getCaption()
{
	return m_caption;
}