/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 
// Locales.cpp

#include "Locales.h"
#include "StringUtils.h"

using namespace VCF;


/**
*this was defined here - but for some reason it wouldnot get created.
*Moving the declaration to UIToolkit.cpp seemed to do the trick
*
*/

Locales VCF::Locales::localListing;


Locales::Locales()
{	
	m_countryMap[LOCALE_USA] = 
		new Locale( "en", "English", LOCALE_USA, LOCALE_USA_CODE );
	m_countryMap[LOCALE_DEFAULT] = 
		new Locale( "default", "default", LOCALE_DEFAULT, LOCALE_DEFAULT_CODE );
}

Locales::~Locales()
{
	std::map<String,Locale*>::iterator it = m_countryMap.begin();
	while ( it != m_countryMap.end() ){
		delete it->second;
		it ++;
	}
	m_countryMap.clear();
}	

Locale* Locales::getLocale( const String& country )
{
	std::map<String,Locale*>::iterator found = 
		Locales::localListing.m_countryMap.find( country );

	Locale* result = NULL;
	if ( found != Locales::localListing.m_countryMap.end() ){
		result = found->second;
	}

	return result;
}