/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

#include "OpenGLControl.h"
#include "OpenGLControlContext.h"
#include "VCFOpenGL.h"
using namespace VCF;

OpenGLControl::OpenGLControl():	
	CustomControl( true )
{
	delete this->m_context;
	m_context = NULL;
	m_context = new OpenGLControlContext( this );
}

OpenGLControl::~OpenGLControl()
{

}

void OpenGLControl::paint(GraphicsContext * context)
{
	CustomControl::paint( context );
	OpenGLControlContext* glCtx = dynamic_cast<OpenGLControlContext*>(m_context);
	if ( NULL != glCtx ){
		glCtx->initGL();
		glViewport( 0, 0, 300, 300 );
		glLoadIdentity();
		glOrtho( 0.0f, 300.0f, 0.0f, 300.0f, 1.0f, -1.0f );
		glClearColor( 0.0f, 0.0f, 1.0f, 1.0f );
		glClear( GL_COLOR_BUFFER_BIT );
		glColor3f( 1.0f, 0.0f, 0.0f );
		glRectf( 100.0f, 150.0f, 150.0f, 200.0f );
		auxWireTeapot( 100.0f );
		glFlush();

		glCtx->swapBuffers();
	}
}

void OpenGLControl::afterCreate( ComponentEvent* event )
{	
	CustomControl::afterCreate( event );	
}