/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */


#include "Panel.h"
#include "Rect.h"
#include "Border.h"
#include "Basic3DBorder.h"


using namespace VCF;

Panel::Panel():
	CustomControl( true )
{	
	this->init();
}

Panel::~Panel()
{

}

void Panel::init()
{
	this->setBorder( new Basic3DBorder() );
	this->setContainer( this );	
}

void Panel::paint( GraphicsContext * context )
{
	CustomControl::paint( context );
	this->paintChildren( context );
}

void Panel::setCaption( const String& caption )
{
	this->m_caption = caption;
}

String Panel::getCaption()
{
	return this->m_caption;
}

void Panel::resizeChildren()
{
	if ( true == alignWork() ){
		
		Rect bounds(0,0,0,0);
		Border* border = this->getBorder();
		if ( NULL != border ){
			bounds = *border->getClientRect( this );
		}
		else {
			bounds.setRect( 0,0, this->getBounds()->getWidth(), this->getBounds()->getHeight() );
		}
		//Rect rect( bounds->m_left, bounds->m_top, bounds->getWidth(), bounds->getHeight() );
		this->doAlign( ALIGN_TOP, &bounds );
		this->doAlign( ALIGN_BOTTOM, &bounds );
		this->doAlign( ALIGN_LEFT, &bounds );
		this->doAlign( ALIGN_RIGHT, &bounds );
		this->doAlign( ALIGN_CLIENT, &bounds );
	}
}

String Panel::toString()
{
	String result = "";

	result += "<object class=\"" + this->getClassName() + "\"> \n";

	Class* clazz = this->getClass();
	if ( NULL != clazz ){
		Enumerator<Property*>* props =  clazz->getProperties();		
		
		while ( props->hasMoreElements() ){
			Property* p = props->nextElement();
			result += "\t" + p->toString() + "\n";
		}
	}

	//now dump out all the components
	result += "<children> \n";
	std::vector<Control*>::iterator it = m_controls.begin();
	while ( it != m_controls.end() ){
		Control* component = *it;
		if ( NULL != component ){
			result += component->toString() + "\n";
		}
		it++;
	}
	result += "</children> \n";
	result += "</object>";
	//m_components
	return result;
}
