/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#include "Point.h"
#include <math.h>

using namespace VCF;

VCF::Point::Point( const double & x, const double & y )
{
	init();
	this->m_x = x;
	this->m_y = y;
}

VCF::Point::Point()
{
	init();
}

void VCF::Point::init()
{
	this->m_x = 0.0;
	this->m_y = 0.0;
}

bool VCF::Point::closeTo( const double& x, const double& y, const double& tolerance )
{
	bool result = false;
	result = (::fabs(m_x - x) <= tolerance) && (::fabs(m_y - y) <= tolerance);
	return result;
}

bool VCF::Point::closeTo( const VCF::Point& pt, const double& tolerance )
{
	return this->closeTo( pt.m_x, pt.m_y, tolerance );
}

String VCF::Point::toString() 
{
	char txt[256];
	memset( txt, 0, 256 );
	sprintf( txt, "x: %.3f, y: %.3f", m_x, m_y );
	
	return String( txt );
};
