/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

// PropertyEditorManager.cpp


#include "PropertyEditorManager.h"

using namespace VCF;

PropertyEditorManager PropertyEditorManager::propertyEditorMgr;

PropertyEditorManager::PropertyEditorManager()
{
	
}

PropertyEditorManager::~PropertyEditorManager()
{
	std::map<String,PropertyEditor*>::iterator it = m_propertEditorMap.begin();
	while ( it != m_propertEditorMap.end() ){
		PropertyEditor* pe = it->second;
		delete pe;
		it++;
	}
	m_propertEditorMap.clear();
}

PropertyEditor* PropertyEditorManager::findEditor( const String& className )
{
	std::map<String,PropertyEditor*>::iterator found = 
		PropertyEditorManager::propertyEditorMgr.m_propertEditorMap.find( className );
	PropertyEditor* result = NULL;
	if ( found != PropertyEditorManager::propertyEditorMgr.m_propertEditorMap.end() ){
		result = found->second;
	}
	return result;
}

void PropertyEditorManager::registerPropertyEditor( PropertyEditor* editor, const String& className )
{
	PropertyEditorManager::propertyEditorMgr.m_propertEditorMap[className] = editor;
}

void PropertyEditorManager::initPropertyEditorManager()
{
	//PropertyEditorManager::propertyEditorMgr = new PropertyEditorManager();
}

void PropertyEditorManager::closePropertyEditorManager()
{
	/*
	try{
		if ( NULL != PropertyEditorManager::propertyEditorMgr ){
			delete PropertyEditorManager::propertyEditorMgr;
		}
		PropertyEditorManager::propertyEditorMgr = NULL;
	}
	catch(...) {

	}
	*/
}