/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#include "Rect.h"
#include <math.h>

using namespace VCF;


VCF::Rect::Rect( const double & left, const double & top, const double & right, const double & bottom )
{	
	this->setRect( left, top, right, bottom );
}

VCF::Rect::Rect()
{	
	this->setRect( 0.0, 0.0, 0.0, 0.0 );
}

VCF::Rect::Rect( const Rect& rect )
{	
	this->setRect( rect.m_left, rect.m_top, rect.m_right, rect.m_bottom );
}

void VCF::Rect::inflate( const double & x, const double & y )
{
	this->m_left += (-x);
	this->m_right += x;

	this->m_top += (-y);
	this->m_bottom += y;
}

bool VCF::Rect::containsRect( Rect* rect )
{
	return false;
}

bool VCF::Rect::containsPt( Point * point )
{
	bool result = false;
	if ( (point->m_x >= this->m_left) &&  (point->m_y >= this->m_top) &&
	     (point->m_x < this->m_right) &&  (point->m_y < this->m_bottom) ){
		result = true;
	}
	return result;
}

void VCF::Rect::normalize()
{

}

double VCF::Rect::getHeight()
{
	return fabs( this->m_bottom - this->m_top );
}

double VCF::Rect::getWidth()
{
	return fabs( this->m_right - this->m_left );
}

bool VCF::Rect::operator == ( const Rect& rectToCompare )const 
{
	bool result = false;
	
	result = (this->m_bottom == rectToCompare.m_bottom) &&
			     (this->m_right == rectToCompare.m_right) &&
				 (this->m_top == rectToCompare.m_top) &&
				 (this->m_left == rectToCompare.m_left);	
	
	return result;
}

void VCF::Rect::setRect( const double & left, const double & top, const double & right, const double & bottom )
{
	this->m_left = left;
	this->m_right = right;
	this->m_top = top;
	this->m_bottom = bottom;
}

String VCF::Rect::toString()
{
	String result = "";

	char tmp[256];
	memset(tmp, 0, 256 );
	sprintf( tmp, "%.3f,%.3f,%.3f,%.3f", m_left, m_top, m_right, m_bottom );
	
	result = tmp;

	return result;
}

void VCF::Rect::saveToStream( OutputStream * stream )
{
	stream->write( m_left );
	stream->write( m_top );
	stream->write( m_right );
	stream->write( m_bottom );
}

void VCF::Rect::loadFromStream( InputStream * stream )
{
	stream->read( m_left );
	stream->read( m_top );
	stream->read( m_right );
	stream->read( m_bottom );
}
