/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */


#include "TextControl.h"
#include "TextPeer.h"
#include "UIToolkit.h"
#include "ClassRegistry.h"
#include "DefaultTextModel.h"
#include "InvalidPeer.h"


using namespace VCF;

TextControl::TextControl()
{
	m_model = new DefaultTextModel();

	m_Peer =	UIToolkit::getDefaultUIToolkit()->createTextPeer( this );
	m_textPeer = dynamic_cast<TextPeer*>( m_Peer );	

	if ( NULL == this->m_textPeer ){
		throw InvalidPeer(MAKE_ERROR_MSG(NO_PEER), __LINE__);
	};
	this->init();
}

TextControl::~TextControl()
{
	if ( NULL != m_model ){
		delete m_model;
		m_model = NULL;
	}
}

void TextControl::init()
{
	
	this->setFocus( true );
	this->setEnabled( true );
	
}

void TextControl::setTextModel( TextModel * model )
{
	if ( NULL != m_model ){
		delete m_model;
		m_model = NULL;
	}
	this->m_model = model;
}

TextModel* TextControl::getTextModel()
{
	return this->m_model;
}

unsigned long TextControl::getCaretPosition()
{
	if ( NULL == this->m_textPeer ){
		throw InvalidPeer(MAKE_ERROR_MSG(NO_PEER), __LINE__);
	};	
	unsigned long result = 0;
	result = m_textPeer->getCaretPosition();
	return result;

}