/**
*Visual Component Framework for C++
*
*Copyright  2000 Jim Crafton
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
*Contact Jim Crafton at ddiego@one.net for more information about the 
*Visual Component Framework
*/ 

/* Generated by Together */

#include "TreeControl.h"
#include "UIToolkit.h"
#include "ClassRegistry.h"
#include "DefaultTreeModel.h"
#include "InvalidPeer.h"
#include "TreePeer.h"
#include "ImageList.h"


using namespace VCF;

TreeControl::TreeControl()
{
	m_Peer = UIToolkit::getDefaultUIToolkit()->createTreePeer( this );
	m_treePeer = dynamic_cast<TreePeer*>( m_Peer );
	
	if ( NULL == this->m_treePeer ){
		throw InvalidPeer(MAKE_ERROR_MSG(NO_PEER), __LINE__);
	};
	this->init();	
}
	
TreeControl::~TreeControl()
{
	delete m_treeModel;
	delete m_treeHandler;
	m_treeModel = NULL;
}

void TreeControl::init()
{
	

	m_treeModel = new DefaultTreeModel();

	m_treeHandler = new TreeModelHandler( this );	

	m_treeHandler->m_rootNodeChanged = (OnTreeModelEvent)this->onTreeRootNodeChanged;

	m_treeModel->addTreeModelListener( m_treeHandler );
}

void TreeControl::setTreeModel( TreeModel * model )
{
	if ( NULL != m_treeModel ){
		delete m_treeModel;
		m_treeModel = NULL;
	}
	m_treeModel = model;
}

TreeModel* TreeControl::getTreeModel()
{
	return m_treeModel;
}

void TreeControl::getImageList()
{

}

void TreeControl::setImageList()
{

}

void TreeControl::paint( GraphicsContext * context )
{

}

void TreeControl::onTreeRootNodeChanged( TreeModelEvent* event )
{
	TreeItem* item = event->getTreeItem();
	this->m_treePeer->addItem( item );
}