// NetToolkit.cpp


#include "NetToolkit.h"
#include "SocketPeer.h"

#ifdef WIN32
#include "Win32SocketPeer.h"
#endif

using namespace VCF;
using namespace VCFNet;

NetToolkit NetToolkit::netToolkitInstance;

NetToolkit::NetToolkit()
{

}

NetToolkit::~NetToolkit()
{

}

NetToolkit* NetToolkit::getDefaultNetToolkit()
{
	return &NetToolkit::netToolkitInstance;
}

SocketPeer* NetToolkit::createSocketPeer()
{
#ifdef WIN32
	return new Win32SocketPeer();
#else
	return NULL;
#endif
}

SocketPeer* NetToolkit::createSocketPeer( const VCF::String& host, const int& port )
{
#ifdef WIN32
	return new Win32SocketPeer( host, port );
#else
	return NULL;
#endif
}