// Socket.cpp:


#include "Socket.h"
#include "SocketPeer.h"
#include "ClassRegistry.h"
#include "NetToolkit.h"

using namespace VCFNet;
using namespace VCF;


Socket::Socket()
{
	this->m_socketPeer = 
		NetToolkit::getDefaultNetToolkit()->createSocketPeer();
}

Socket::Socket( const int& port )
{
	m_socketPeer = 
		NetToolkit::getDefaultNetToolkit()->createSocketPeer( VCFNET_NOHOST, port );
}

Socket::Socket( const VCF::String& host, const int& port )
{
	this->m_socketPeer = 
		NetToolkit::getDefaultNetToolkit()->createSocketPeer( host, port );
}

Socket::~Socket()
{
	delete this->m_socketPeer;
}

int Socket::getPort()
{
	return this->m_socketPeer->getPort();
}

void Socket::setPort( const int& port )
{
	this->m_socketPeer->setPort( port );
}

VCF::String Socket::getHost()
{
	return this->m_socketPeer->getHost();
}

void Socket::setHost( const VCF::String& host )
{
	this->m_socketPeer->setHost( host );
}

int Socket::send( const char* bytes, const uint32& size )
{
	return this->m_socketPeer->send( bytes, size );	
}